Package: JuliaConnectoR
Type: Package
Title: A Functionally Oriented Interface for Integrating 'Julia' with R
Version: 1.1.3
Maintainer: Stefan Lenz <stefan-m-lenz@web.de>
Authors@R: c(person("Stefan", "Lenz", role = c("aut", "cre"),
                    email = "stefan-m-lenz@web.de",
                    comment = c(ORCID = "0000-0001-9135-1743")),
             person("Harald", "Binder", role = c("aut", "ths"),
                    comment = c(ORCID = "0000-0002-5666-8662")),
             person("Angelo", "D\'Ambrosio",
                    comment = c(ORCID = "0000-0002-2045-5155"), role = "ctb"))
Description: Allows to import functions and whole packages from 'Julia' in R.
    Imported 'Julia' functions can directly be called as R functions.
    Data structures can be translated between 'Julia' and R.
    More details can also be found in the corresponding article
    <doi:10.18637/jss.v101.i06>.
License: MIT + file LICENCE
SystemRequirements: Julia >= 1.0
Encoding: UTF-8
RoxygenNote: 7.2.3
Suggests: testthat (>= 2.1.0), future, parallel
NeedsCompilation: no
Packaged: 2023-12-06 13:57:28 UTC; lenzstef
Author: Stefan Lenz [aut, cre] (<https://orcid.org/0000-0001-9135-1743>),
  Harald Binder [aut, ths] (<https://orcid.org/0000-0002-5666-8662>),
  Angelo D'Ambrosio [ctb] (<https://orcid.org/0000-0002-2045-5155>)
Repository: CRAN
Date/Publication: 2023-12-06 15:30:02 UTC
Built: R 4.4.0; ; 2024-05-01 13:31:33 UTC; unix

struct RDataFrame <: AbstractColumns
   ellist::ElementList
end

istable(::Type{RDataFrame}) = true
columnaccess(::Type{RDataFrame}) = true
columns(df::RDataFrame) = df
columnnames(df::RDataFrame) = getfield(getfield(df, :ellist), :names)

function getcolumn(df::RDataFrame, nm::Symbol)
   getfield(getfield(df, :ellist), :namedelements)[nm]
end

function getcolumn(df::RDataFrame, i::Int)
   getfield(getfield(df, :ellist), :namedelements)[getfield(df, :names)[i]]
end

function getcolumn(df::RDataFrame, ::Type{T}, col::Int, nm::Symbol) where {T}
   getcolumn(df, nm)
end


function r_compatible_type(t::Type{Char})
   Int32
end

function r_compatible_type(t::Type{T}) where T <: AbstractString
   String
end

function r_compatible_type(t::Type{Int32})
   Int32
end

function r_compatible_type(t::Type{Bool})
   Bool
end

function r_compatible_type(t::Type{T}) where {T2, T <: Complex{T2}}
   Complex{T2}
end

function r_compatible_type(t::Type{T}) where T <: Number
   Float64
end

function r_compatible_type(t::Type{Missing})
   Missing
end

function r_compatible_type(t::Type{Union{Missing, T}}) where T <: Union{Number, Bool, Char, AbstractString}
   Union{Missing, r_compatible_type(T)}
end

function r_compatible_type(t::Type{T}) where T <: Any
   error("Column type \"$(T)\" cannot be translated to a type that can be used in an R data frame")
end

function convert_to_r_compatible_type(x::AbstractArray{T}) where T
   convert(Array{r_compatible_type(T)}, x)
end


"""
Convert an object implementing the Tables.jl interface to an RDataFrame object
"""
function get_df(obj)
   coldict = Dict{Symbol, Any}()
   attributes = Dict{String, Any}()
   cols = columns(obj)
   colnames = columnnames(cols)
   for col in columnnames(cols)
      coldict[Symbol(col)] = convert_to_r_compatible_type(getcolumn(cols, col))
   end
   colnamesarr = Symbol.(collect(colnames))

   if length(colnamesarr) > 0
      allsame(x) = all(y -> y == first(x), x)
      if !allsame(map(length, values(coldict)))
         error("Lengths of columns not equal")
      end
   end

   RDataFrame(ElementList([], colnamesarr, coldict, attributes))
end

library(JuliaConnectoR)

# Test BoltzmannMachines package
# If not installed, install the current version via
# juliaEval('using Pkg; Pkg.add("BoltzmannMachines"))')

# Set a random seed in Julia
juliaEval("using Random; Random.seed!(5);")

BM <- juliaImport("BoltzmannMachines")

# a test data set from the BoltzmannMachines-package, just to have some data
x <- BM$barsandstripes(100L, 4L)
x

# Train DBMs with
dbm <- BM$fitdbm(x, epochs = 40L, learningrate = 0.05,
                 nhiddens = c(4L,3L))
dbm
dbm2 <- BM$fitdbm(x, epochs = 10L,
                  pretraining = list(BM$TrainLayer(nhidden = 4L),
                                     BM$TrainLayer(nhidden = 3L)))
dbm2

# Use a trained model to generate samples
BM$samples(dbm, 10L)

# Evaluate the model: Likelihood estimation ...
BM$loglikelihood(dbm2, x)
#  ... or exact calculation (possible for such a small model)
BM$exactloglikelihood(dbm2, x)

# RBM-fitting with simple monitoring, e. g. just print the progress in R
rbm <- BM$fitrbm(x, epochs = 20L,
                 monitoring = function(rbm, epoch) {print(epoch)})


# Now real monitoring with callback functions
# (Abusing environments for call-by-reference value collection)
monitor <- new.env(parent = emptyenv())
monitor$loglik <- c()
rbm <- BM$fitrbm(x, epochs = 100L,
                 monitoring = function(rbm, epoch) {
                    monitor$loglik <- c(monitor$loglik, BM$loglikelihood(rbm, x))
                 })
plot(1:100, monitor$loglik, "l")

juliaEval("Random.seed!(5);")

# A complex dbm example with layerwise monitoring
monitor <- new.env(parent = emptyenv())
dbm <- BM$fitdbm(x, epochs = 60L,
                 learningrate = 0.05,
                 learningratepretraining = 0.01,
                 pretraining = list(
                       BM$TrainLayer(nhidden = 4L, epochs = 70L,
                              monitoring = function(rbm, epoch) {
                                 monitor$layer1 <- c(monitor$layer1,
                                                     BM$reconstructionerror(rbm, x))
                              }),
                        BM$TrainLayer(nhidden = 3L, epochs = 50L,
                              monitoring = function(rbm, epoch) {
                                 monitor$layer2 <- c(monitor$layer2,
                                                     BM$reconstructionerror(rbm, x))
                             })),
               monitoring = function(dbm, epoch) {
                  monitor$logproblowerbound <- c(monitor$logproblowerbound,
                                                 BM$exactloglikelihood(dbm, x))
               }
)
plot(1:70, monitor$layer1, "l")
plot(1:50, monitor$layer2, "l")
plot(1:60, monitor$logproblowerbound, "l")


# First approach for Gibbs-Sampling, allows access to hidden nodes
particles <- BM$initparticles(dbm2, 20L)
particles <- BM$`gibbssample!`(particles, dbm2, 100L)
particles

# Second approach for Gibbs sampling: All-in-one, returning only visible nodes
BM$samples(dbm, 5L)

# Conditional Gibbs sampling
BM$samples(dbm, 5L, conditions = juliaEval("[1 => 1.0, 2 => 0.0]"))


# A Gaussian-BernoulliRBM
rbm <- BM$fitrbm(data.matrix(iris[, 1:4]), rbmtype = BM$GaussianBernoulliRBM)
BM$samples(rbm, 10L)

function getprop(value, name)
   getproperty(value, Symbol(name))
end

# "d$key" will result in a lookup instead of a access of fields
function getprop(d::AbstractDict{K, V}, key::K) where {K, V}
   d[key]
end


function setprop!(value, name, x)
   setproperty!(value, Symbol(name), x)
   return nothing
end

function setprop!(d::AbstractDict{K, V}, key::K, x) where {K, V}
   d[key] = x
   return nothing
end


"""
    dimensionidxs(x)
Returns a proper index for one dimension when indexing multiple elements in
a multidimensional array.
"""
function dimensionidxs(x)
   x
end

function dimensionidxs(x::Number)
   [Int(x)]
end

function dimensionidxs(x::AbstractArray{Float64})
   convert(Vector{Int}, x)
end


"""
    getidx(collection, key)
Extract a single element from a collection.
Called by `collection[[key]]` in R.
"""
function getidx(collection, key)
   getindex(collection, key)
end

# get one element in a multidimensional array
function getidx(collection, key::Vararg{<:Number})
   intkey = map(Int, key)
   getindex(collection, intkey...)
end


"""
    getidxs(collection, idx)
Access multiple elements in a collection.
Called via "collection[idx]" in R.
Expected to return a vector or a vector-like object.
The exact return type may depend on the implementation of `getindex`
of the specific collection.
"""
function getidxs(collection, idx::Number)
   getindex(collection, [idx])
end

# indexing with e.g. v[1]
function getidxs(collection, idx::Float64)
   getindex(collection, [Int(idx)])
end

# indexing with e.g. v[1:4]
function getidxs(collection, idxs::Vector{Float64})
   getindex(collection, map(Int, idxs))
end

# indexing with e.g. v[v > 4]
function getidxs(collection, idxs::Union{AbstractVector, AbstractRange})
   getindex(collection, idxs)
end

# multidimensional indexing with a single index, e.g. v[1,2,3]
function getidxs(collection,
      keys::Vararg{<:Union{AbstractArray, AbstractRange, Float64, Int}})
   dimidxs = map(dimensionidxs, keys)
   getindex(collection, dimidxs...)
end

# indexing dictionary with e.g. d["hi"]
function getidxs(d::AbstractDict{K, V}, key::K) where {K, V}
   [d[key]]
end

# indexing dictionary with e.g. d[c("hi", "you")]
function getidxs(d::AbstractDict{K, V}, keys::Vararg{K}) where {K, V}
   ret = Vector{V}(undef, length(keys))
   for i in eachindex(keys)
      ret[i] = d[keys[i]]
   end
   ret
end


"""
    setidx!(collection, value, key)
Set a single element in a collection.
Called by `collection[[key]] <- value` in R.
"""
function setidx!(collection, value, key)
   setindex!(collection, value, key)
   return nothing
end

# replace single element in multidimensional array
function setidx!(collection, value, key::Vararg{<:Number})
   intkey = map(Int, key)
   setindex!(collection, value, intkey...)
   return nothing
end


function check_lengths_for_assignment(keys, values)
   if length(values) != length(keys)
      error("Number of items to replace is not equal to replacement length")
   end
end


"""
    setidxs!(collection, values, keys)
Set multiple elements in a collection.
Called by `collection[key] <- value` in R.
"""
function setidxs!(collection, value,
      keys::Vararg{<:Union{AbstractArray, AbstractRange, Float64, Int}})

   dimidxs = map(dimensionidxs, keys)
   collection[dimidxs...] .= value
   return nothing
end

# replace single element in multidimensional array
function setidxs!(collection, value, key::Vararg{<:Union{Int, Float64}})
   intkey = map(Int, key)
   setindex!(collection, value, intkey...)
   return nothing
end

# replace multiple elements in a multidimensional array with multiple values
function setidxs!(collection::AbstractArray{T}, value::AbstractArray{T},
      keys::Vararg{<:Union{AbstractArray, AbstractRange, Float64, Int}}) where T

   dimidxs = map(dimensionidxs, keys)
   collection[dimidxs...] .= value
   return nothing
end

# replace multiple elements in a multidimensional array with a single value
function setidxs!(collection::AbstractArray{T}, value::T,
      keys::Vararg{<:Union{AbstractArray, AbstractRange, Float64, Int}}) where T

   dimidxs = map(dimensionidxs, keys)
   collection[dimidxs...] .= repeat([value], length.(keys)...)
   return nothing
end

# replace single element in dictionary with e.g. d["hi"]
function setidxs!(d::AbstractDict{K, V}, value, key::K) where {K, V}
   d[key] = value
   return nothing
end

# replace multiple elements in dictionary with e.g. d[c("hi", "you")]
function setidxs!(d::AbstractDict{K, V}, values::Vector, keys::Vararg{K}) where {K, V}
   check_lengths_for_assignment(keys, values)
   map(i -> d[keys[i]] = values[i], eachindex(keys))
   return nothing
end

function getdim(x::T) where {T <: Union{AbstractArray, Tuple}}
   collect(size(x))
end

library(testthat)
library(JuliaConnectoR)
library(utils)

if (juliaSetupOk()) {
   test_check("JuliaConnectoR")
} else if (Sys.getenv("GITHUB_ACTIONS") == "true") {
   stop("Julia setup on GitHub Actions is not OK")
}

import Pkg
if VERSION < v"1.4"
   if get(Pkg.installed(), "Tables", v"0.0") < v"1.0"
      include("./dummy_tables.jl")
      @eval import .Tables
   else
      @eval import Tables
   end
else
   # no check for correct version of Tables in Julia 1.4 since
   # Pkg.dependencies() is "experimental" and Pkg.installed is deprecated
   try
      @eval import Tables
   catch ex
      include("./dummy_tables.jl")
      @eval import .Tables
   end
end

using InteractiveUtils # for convenience: this is loaded in the standard REPL as well

include("./RConnector.jl")
RConnector.serve(parse(Int, ARGS[1]), portfile = ARGS[2],
   multiclient = (ARGS[3] == "t"))

module RConnector

using Sockets
using Logging
import REPL
import Main.Tables: istable, columnaccess,
                    columns, AbstractColumns,
                    getcolumn, columnnames

const TYPE_ID_NOTHING = 0x00
const TYPE_ID_FLOAT64 = 0x01
const TYPE_ID_COMPLEX = 0x02
const TYPE_ID_RAW = 0x03
const TYPE_ID_INT = 0x04
const TYPE_ID_BOOL = 0x05
const TYPE_ID_STRING = 0x06
const TYPE_ID_LIST = 0x07
const TYPE_ID_EXPRESSION = 0xee
const TYPE_ID_CALLBACK = 0xcb
const TYPE_ID_NAMED_FUNCTION = 0xfc
const TYPE_ID_OBJECT_REFERENCE = 0xce
const TYPE_ID_SYMBOL = 0x5b

const OBJECT_CLASS_ID_ARRAY = 0xaa
const OBJECT_CLASS_ID_SIMPLE_ARRAY = 0x5a
const OBJECT_CLASS_ID_ANONYMOUS_FUNCTION = 0xaf
const OBJECT_CLASS_ID_STRUCT = 0x5c
const OBJECT_CLASS_ID_NO_INFO = 0x00

const CALL_INDICATOR = 0x01
const RESULT_INDICATOR = 0x00
const STDOUT_INDICATOR = 0x50
const STDERR_INDICATOR = 0x5e
const FAIL_INDICATOR = 0xff
const BYEBYE = 0xbb

const NO_ATTRIBUTES = Base.ImmutableDict{String, Any}()

const SEND_AS_RAW_TYPES = Union{UInt64, Int128, UInt128, Ptr}
const SEND_AS_INT32 = Union{Int8, Int16, UInt16, Char}
const SEND_AS_DOUBLE = Union{Float16, Float32, UInt32}
const SEND_AS_COMPLEX = Complex{T} where T <: Union{
      Int8, Int16, Int32, Int64, Float16, Float32}

const R_NA_INTEGER = Int32(-2147483648)
const R_NA_REAL = ntoh(reinterpret(Float64,
      UInt8[0x7f, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x07, 0xa2])[1])
const R_NA_COMPLEX = Complex{Float64}(R_NA_REAL, R_NA_REAL)

include("communicating.jl")
include("sharing.jl")
include("handling_undefined.jl")
include("reading.jl")
include("handling_dataframes.jl")
include("evaluating.jl")
include("writing.jl")
include("exporting.jl")
include("accessing_mutating.jl")

end

struct ObjectReference
   ref::UInt64
end


mutable struct CallbackFinalizer
   id::String
   f::Function
   communicator::CommunicatoR
end

function finalize_callback(cb::CallbackFinalizer)
   lock(cb.communicator.callbacks_lock)
   try
      delete!(cb.communicator.registered_callbacks, cb.f)
      push!(cb.communicator.finalized_callbacks, cb.id)
   finally
      unlock(cb.communicator.callbacks_lock)
   end
end


function register_callback(communicator::CommunicatoR, f::Function, callbackid::String)
   lock(communicator.callbacks_lock)
   try
      communicator.registered_callbacks[f] = callbackid
   finally
      unlock(communicator.callbacks_lock)
   end
end


function funtocallbackid(communicator::CommunicatoR, f::Function)
   callbackid = ""
   lock(communicator.callbacks_lock)
   try
      callbackid = get(communicator.registered_callbacks, f, "")
   finally
      unlock(communicator.callbacks_lock)
   end
   callbackid
end


function CallbackFinalizer(id::String, communicator::CommunicatoR)
   f = identity # any function does the job
   cb = CallbackFinalizer(id, f, communicator)
   finalizer(finalize_callback, cb)
   cb
end

const useless_counter = Ref(0)
function stayalivewithme(cb::CallbackFinalizer)
   # accessing a global variable will prevent this function from
   # being optimized out, even by super clever optimizers
   useless_counter.x += 1
end


function full_translation!(communicator::CommunicatoR, mode::Bool)
   communicator.full_translation = mode
end


function sharedheapget(communicator::CommunicatoR, ref::UInt64)
   lock(communicator.sharedheap_lock)
   ret = communicator.sharedheap[ref].obj
   unlock(communicator.sharedheap_lock)
   ret
end

function sharedheapget(communicator::CommunicatoR, objref::ObjectReference)
   sharedheapget(communicator, objref.ref)
end


mutable struct ImmutableObjectReference
   obj::Any
end


function object_reference(obj)
   UInt64(pointer_from_objref(obj))
end


function share_mutable_object!(communicator, obj)
   ref = object_reference(obj)
   lock(communicator.sharedheap_lock)
   try
      if haskey(communicator.sharedheap, ref)
         communicator.sharedheap[ref].refcount += 1
      else
         communicator.sharedheap[ref] = SharedObject(obj)
      end
   finally
      unlock(communicator.sharedheap_lock)
   end
   ref
end


function share_immutable_object!(communicator, obj)
   obj2 = ImmutableObjectReference(obj)
   ref = object_reference(obj2)
   # the object is newly created and cannot exists already
   lock(communicator.sharedheap_lock)
   try
      communicator.sharedheap[ref] = SharedObject(obj2)
   finally
      unlock(communicator.sharedheap_lock)
   end
   ref
end


function shareobject!(communicator, obj)
   if isimmutable(obj)
      return share_immutable_object!(communicator, obj)
   else
      return share_mutable_object!(communicator, obj)
   end
end


function parseheapref(ref::Vector{UInt8})
   UInt64(reinterpret(UInt64, ref)[1])
end


function decrefcount!(communicator::CommunicatoR, ref::UInt64)
   lock(communicator.sharedheap_lock)
   try
      newrefcount = communicator.sharedheap[ref].refcount - 1
      if newrefcount == 0
         delete!(communicator.sharedheap, ref)
      else
         communicator.sharedheap[ref].refcount = newrefcount
      end
   finally
      unlock(communicator.sharedheap_lock)
   end
end

function decrefcounts(communicator::CommunicatoR, refs::Vector{UInt8})
   for ref in reinterpret(UInt64, refs)
      decrefcount!(communicator, ref)
   end

   # return finalized callbacks and clear list
   lock(communicator.callbacks_lock)
   ret = deepcopy(communicator.finalized_callbacks)
   empty!(communicator.finalized_callbacks)
   unlock(communicator.callbacks_lock)

   ret
end


function sharedfinalizer(communicator::CommunicatoR, newobj, oldobjref::UInt64)
   # If a new Julia heap object is recreated via backtranslation from R,
   # it must reference the original object such that this one lives on.
   # It must be prevented that the old object is garbage collected because
   # this might finalize resources that are needed for the copy to work.
   lock(communicator.sharedheap_lock)
   try
      if haskey(communicator.sharedheap, oldobjref)
         communicator.sharedheap[oldobjref].refcount += 1
         finalizer(obj -> decrefcount!(communicator, oldobjref), newobj)
      else
         @warn "Please be sure that the revived objects " *
               "do not contain external references."
      end
   finally
      unlock(communicator.sharedheap_lock)
   end
end


mutable struct EnforcedProxy{T}
   obj::T
end

struct Fail
   message::String
end

function Fail(msg, origex, origex_backtrace)
   Fail(msg * "\nOriginal Julia error message:\n" *
         sprint(showerror, origex, origex_backtrace))
end


struct ElementList
   positionalelements::Vector{Any}
   names::Vector{Symbol}
   namedelements::Dict{Symbol, Any}
   attributes::Dict{String, Any}
   parsingfails::Vector{Fail}
end

function ElementList(unnamed::Vector{Any} = Vector{Any}(),
      names::Vector{Symbol} = Vector{Symbol}(),
      named::Dict{Symbol, Any} = Dict{Symbol, Any}(),
      attributes = Dict{String, Any}())
   ElementList(unnamed, names, named, attributes, Vector{Fail}())
end

function ElementList(unnamed::Vector{Any},
      named::Dict{Symbol, Any} = Dict{Symbol, Any}(),
      attributes = Dict{String, Any}())

   ElementList(unnamed, collect(keys(named)), named, attributes, Vector{Fail}())
end


struct Call
   fun::Union{Function, Type, Module}
   args::ElementList
   parsingfails::Vector{Fail}

   function Call(fun::Union{Function, Type} = () -> nothing,
      args::ElementList = ElementList(),
      parsingfails::Vector{Fail} = Vector{Fail}())

      new(fun, args, parsingfails)
   end
end


function isbitsequal(x)
   y -> x .=== y
end


# replace `value` in `x` with `replacement`
# but use === comparison instead of == as the normal replace does
function replace_bitsequal(x, val, replacement)
   [(x[i] === val ? replacement : x[i]) for i in eachindex(x)]
end


# represents_na shall be equivalent to the R_IsNA function.
# See https://github.com/wch/r-source/blob/502561df523f1dc0430dfe5862c6a174c7067b4f/src/main/arithmetic.c#L126-L137
# and https://cran.r-project.org/doc/manuals/r-devel/R-data.html#Special-values
# " [...] NA is represented by the NaN value with low-word 0x7a2 (1954 in decimal)."
const magicnumber1954shifted = (UInt64(1954) << 32)
function represents_na(x::Float64)
   isnan(x) && (reinterpret(UInt64, x) << 32) == magicnumber1954shifted
end

# Returns true if there is a value in the array x that is a R NA value,
# as is determined by the R_IsNA function.
# Replaces all "dirty" NA values (i.e., values that are considered NA by R,
# but are not bitwise equal to NA_real_ in R) with the exact value of NA_real_
function any_na_normalize!(x::AbstractVector{Float64})
   ret = false
   for i in eachindex(x)
      @inbounds if represents_na(x[i])
         x[i] = R_NA_REAL
         ret = true
      end
   end
   ret
end


function read_attributes(communicator)
   nattributes = read_nattributes(communicator)
   attributes = Dict{String, Any}()
   for i in 1:nattributes
      name = read_string(communicator)
      attributes[name] = read_element(communicator)
   end
   attributes
end


function read_complexs(communicator, n::Int)
   doublepairs = reinterpret(Float64, read_bin(communicator, 16*n))
   map(i -> Complex{Float64}(doublepairs[2*i - 1], doublepairs[2*i]), 1:n)
end


function convert_to_complex_or_missing(re::Float64, im::Float64)
   if represents_na(re) || represents_na(im)
      return missing
   else
      return Complex{Float64}(re, im)
   end
end


function read_complexs_with_missings(communicator, n::Int)
   doublepairs = reinterpret(Float64, read_bin(communicator, 16*n))
   [convert_to_complex_or_missing(doublepairs[2*i - 1], doublepairs[2*i]) for i in 1:n]
end


function read_float64s(communicator, n::Int)
   reinterpret(Float64, read_bin(communicator, 8*n))
end


function read_float64s_with_missings(communicator, n::Int)
   ret = read_float64s(communicator, n)
   if any_na_normalize!(ret)
      return replace_bitsequal(ret, R_NA_REAL, missing)
   else
      return ret
   end
end


function read_ints(communicator, n::Int)
   map(Int, reinterpret(Int32, read_bin(communicator, 4*n)))
end

read_int(communicator) = read_ints(communicator, 1)[1]


function read_ints_with_missings(communicator, n::Int)
   ret = read_ints(communicator, n)
   if any(isequal(R_NA_INTEGER), ret)
      return replace(ret, R_NA_INTEGER => missing)
   else
      return ret
   end
end


function read_nattributes(communicator)
   ret = read_bin(communicator, 1)[1]
end


function read_string(communicator)
   nbytes = read_int(communicator)
   if nbytes > 0
      return String(read_bin(communicator, nbytes))
   else
      return ""
   end
end

function read_strings(communicator, n::Int)
   ret = Vector{String}(undef, n)
   for i = 1:n
      ret[i] = read_string(communicator)
   end
   ret
end


function read_bools(communicator, n::Int)
   reinterpret(Bool, read_bin(communicator, n))
end


function read_dimensions(communicator)
   ndims = read_int(communicator)
   if ndims == 0
      return 0
   else
      return read_ints(communicator, ndims)
   end
end


function read_element(communicator)
   typeid = read_byte(communicator)

   if typeid == TYPE_ID_LIST
      return read_list(communicator)
   elseif typeid == TYPE_ID_NOTHING
      return nothing
   elseif typeid == TYPE_ID_EXPRESSION
      return read_expression(communicator)
   elseif typeid == TYPE_ID_OBJECT_REFERENCE
      # not needed in Julia, ignore for now
      object_class = read_bin(communicator, 1)
      ref = parseheapref(read_bin(communicator, 8))
      return ObjectReference(ref)
   elseif typeid == TYPE_ID_CALLBACK
      callbackid = read_string(communicator)
      callback = callbackfun(callbackid, communicator)
      return callback
   elseif typeid == TYPE_ID_SYMBOL
      return Symbol(read_string(communicator))
   else
      dimensions = read_dimensions(communicator)
      nelements = dimensions == 0 ? 1 : reduce(*, dimensions)

      attributes = NO_ATTRIBUTES
      if typeid == TYPE_ID_FLOAT64
         ret = read_float64s_with_missings(communicator, nelements)
         attributes = read_attributes(communicator)
         return convert_reshape_element(ret, attributes, dimensions)
      elseif typeid == TYPE_ID_INT
         ret = read_ints_with_missings(communicator, nelements)
         attributes = read_attributes(communicator)
         return convert_reshape_element(ret, attributes, dimensions)
      elseif typeid == TYPE_ID_BOOL
         ret = read_bools(communicator, nelements)
         return reshape_element(ret, dimensions)
      elseif typeid == TYPE_ID_STRING
         ret = read_strings(communicator, nelements)
         attributes = read_attributes(communicator)
         return convert_reshape_string(ret, attributes, dimensions)
      elseif typeid == TYPE_ID_COMPLEX
         ret = read_complexs_with_missings(communicator, nelements)
         attributes = read_attributes(communicator)
         return convert_reshape_element(ret, attributes, dimensions)
      elseif typeid == TYPE_ID_RAW
         ret = read_bin(communicator, nelements)
         attributes = read_attributes(communicator)
         return convert_reshape_raw(ret, attributes, dimensions)
      else
         return Fail("Invalid type id $typeid of element")
      end
   end
end


function reshape_element(element, dimensions)
   if dimensions == 0
      return element[1]
   else # dimensions > 0
      return Array(reshape(element, dimensions...))
   end
end


function convert_reshape_element(element, attributes, dimensions)
   typestr = get(attributes, "JLTYPE", "")
   if typestr != ""
      try
         type = maineval(typestr)
         element = convert.(type, element)
      catch ex
         return Fail("Conversion to type \"$typestr\" failed", ex, catch_backtrace())
      end
   end
   return reshape_element(element, dimensions)
end


function convert_reshape_raw(element, attributes, dimensions)
   typestr = get(attributes, "JLTYPE", "")
   if typestr != ""
      try
         type = maineval(typestr)
         if type <: SEND_AS_RAW_TYPES
            element = reinterpret(type, element)
            # adjust dimensions, as the original dimensions are for a UInt8 array
            if length(element) == 1 && isempty(get(attributes, "JLDIM", Int[]))
               dimensions = 0
            else
               dimensions[1] /= sizeof(type)
            end
            element = convert.(type, element)
         elseif type <: String
            # It may be the case that a Julia String can not be handled in R,
            # e.g. if it contains NUL characters. Then it will be encoded in bytes.
            return String(element)
         end
      catch ex
         return Fail("Conversion to type \"$typestr\" failed", ex, catch_backtrace())
      end
   end
   return reshape_element(element, dimensions)
end


function convert_reshape_string(ret::Array{String}, attributes, dimensions)
   if haskey(attributes, "NA")
      ret = convert(Array{Union{String, Missing}}, ret)
      try
         for i in attributes["NA"]
            ret[i] = missing
         end
      catch ex
         return Fail("Translating NAs failed", ex, catch_backtrace())
      end
   end
   return convert_reshape_element(ret, attributes, dimensions)
end


function read_expression(communicator)
   exprstr = read_string(communicator)
   try
      return maineval(exprstr)
   catch ex
      return Fail("Evaluation of \"$exprstr\" failed", ex, catch_backtrace())
   end
end


function read_list(communicator)

   npositional = read_int(communicator)
   positionalelements = Vector{Any}(undef, npositional)
   for i in 1:npositional
      positionalelements[i] = read_element(communicator)
   end

   fails = Vector{Fail}(
         positionalelements[isa.(positionalelements, Fail)])

   nnamed = read_int(communicator)
   names = Vector{Symbol}(undef, nnamed)
   namedelements = Dict{Symbol, Any}()
   for i in 1:nnamed
      name = read_string(communicator)
      namedelement = read_element(communicator)
      try
         sym = Symbol(name)
         namedelements[sym] = namedelement
         names[i] = sym
      catch ex
         push!(fails, Fail("Ignored element with name $name", ex, catch_backtrace()))
      end
   end

   attributes = read_attributes(communicator)

   ElementList(positionalelements, names, namedelements, attributes, fails)
end


function findfield(name::AbstractString)
   # The use of eval here brings a potential security risk if one wants
   # to restrict the functions that can be called somehow
   maineval(name)::Union{Function, Type, Module}
end


# return a function that is the broadcasted version of f,
# corresponding to adding a dot in the call, as
# f.(args...) is actually equivalent to broadcast(f, args...)
# (see Julia documentation of dot syntax for vectorizing functions)
function broadcasted(f::Function)
   (args...; kwargs...) -> broadcast((x...) -> f(x...; kwargs...), args...)
end

function broadcasted(call::Call)
   Call(broadcasted(call.fun), call.args, call.parsingfails)
end


function read_call(communicator)
   name = read_string(communicator)
   if endswith(name, ".")
      funname = name[1:(end-1)]
      return broadcasted(read_call(communicator, funname))
   else
      return read_call(communicator, name)
   end
end

function read_call(communicator, name::AbstractString)
   fails = Vector{Fail}()
   fun = () -> nothing
   try
      fun::Union{Function, Type} = findfield(name)
   catch ex
      push!(fails, Fail("Unable to identify function", ex, catch_backtrace()))
   end
   args = read_list(communicator)
   Call(fun, args, fails)
end

""" Escape latex symbols in given string """
function escapelatexsymbols(str::String)
   if isascii(str)
      return str
   else
      # create a new string where each symbol in the original string
      # is replaced with its latex representation if it has one
      ret = Vector{String}(undef, length(str))
      retindex = 1
      for i in eachindex(str)
         if isascii(str[i])
            ret[retindex] = string(str[i])
         else
            latexname = REPL.symbol_latex(string(str[i]))
            if latexname != ""
               ret[retindex] = "<" * latexname[2:end] * ">"
               if isempty(ret[retindex])
                  ret[retindex] = string(str[i])
               end
            else
               ret[retindex] = string(str[i])
            end
         end
         retindex += 1
      end
      return join(ret)
   end
end


"""
Returns an object that translates to an R list with keys
"original" and "escaped".
Both entries have as values character vectors.
"original" contains all names that have a different version that
contains latex for describing symbols.
"escaped" contains the names with the latex sequences in the same order.
"""
function escapednames(originalnames::Vector{String})
   escaped = escapelatexsymbols.(originalnames)
   needsescaping = (escaped .!= originalnames)
   original = originalnames[needsescaping]
   escaped = escaped[needsescaping]
   ElementList(Vector{Any}(), Dict{Symbol, Any}(
         :original => original, :escaped => escaped))
end


""" Lists the content of a package for import in R"""
function moduleinfo(modulename::AbstractString; all::Bool = false)
   themodule = RConnector.maineval(modulename)::Module

   function symbolisa(sym::Symbol, type)
      if isdefined(themodule, sym)
         field = themodule.eval(sym)
         return field isa type
      else
         return false
      end
   end

   isafunction(sym) = symbolisa(sym, Function)
   isatype(sym) = symbolisa(sym, Type)

   exportedsyms = names(themodule, all = false)
   exportedfunctions = map(string, filter(isafunction, exportedsyms))
   exportedtypes = map(string, filter(isatype, exportedsyms))

   if all
      allsyms = names(themodule, all = true)
      filter!(sym -> string(sym)[1] != '#', allsyms)
      exportedSymSet = Set(exportedsyms)
      internalsyms = filter(sym -> !(sym in exportedSymSet), allsyms)
      internalfunctions = map(string, filter(isafunction, internalsyms))
      internaltypes = map(string, filter(isatype, internalsyms))
      escapedfunctions = escapednames(vcat(exportedfunctions, internalfunctions))
      escapedtypes = escapednames(vcat(exportedtypes, internaltypes))
      return ElementList(Vector{Any}(), Dict{Symbol, Any}(
                  :exportedFunctions => exportedfunctions,
                  :exportedTypes => exportedtypes,
                  :internalFunctions => internalfunctions,
                  :internalTypes => internaltypes,
                  :escapedFunctions => escapedfunctions,
                  :escapedTypes => escapedtypes))
   else
      escapedfunctions = escapednames(exportedfunctions)
      escapedtypes = escapednames(exportedtypes)
      return ElementList(Vector{Any}(), Dict{Symbol, Any}(
                  :exportedFunctions => exportedfunctions,
                  :exportedTypes => exportedtypes,
                  :escapedFunctions => escapedfunctions,
                  :escapedTypes => escapedtypes))
   end
end

""" Representing an #undef value """
struct JLUNDEF
end


""" 
Creates a new array that has `JLUNDEF()` objects in places of undefined values.
"""
function undefs_replaced(arr::AbstractArray)
   ret = Array{Any}(undef, size(arr))
   @inbounds for i in eachindex(arr)
      if isassigned(arr, i)
         ret[i] = arr[i]
      else
         ret[i] = JLUNDEF()
      end
   end
   ret
end


""" 
Copies all elements that are not `JLUNDEF()` from `src`
to the corresponding index in `dst` 
"""
function copy_defined!(dst::Array, src::Array)
   @inbounds for i in eachindex(src)
      if src[i] != JLUNDEF()
         dst[i] = src[i]
      end
   end
   dst
end

module Tables
   const JuliaConnectoR_DummyTables = true
   istable(x) = false
   columnaccess(x) = false
   columns(x) = nothing
   getcolumn(x) = nothing
   columnnames(x) = nothing
   abstract type AbstractColumns end
end

function collectfails(call::Call)
   vcat(call.parsingfails, collectfails(call.args))
end

function collectfails(ellist::ElementList)
   ellist.parsingfails
end

function collectfails(el)
   Fail[]
end

function collectfails(fail::Fail)
   fail
end

"""
Converts a vector to a vector of the most specific type that all
elements share as common supertype.
"""
function converttomostspecifictype(v::Vector)
   if isempty(v)
      return v
   else
      Vector{mostspecifictype(v)}(v)
   end
end


"""
    mostspecifictype(v)
Returns the most specific supertype for all elements in the vector `v`.
"""
function mostspecifictype(v::Vector)
   mapreduce(typeof, typejoin, v)
end

function parsingcheck(el)
   fails = collectfails(el)
   if !isempty(fails)
      error(fails[1].message)
   end
   nothing
end

function evaluate_checked!(call::Call, communicator::CommunicatoR)
   # check parsing first
   try
      parsingcheck(call)
   catch ex
      return Fail("Parsing in Julia failed.", ex, catch_backtrace())
   end

   try
      return evaluate!(call, communicator)
   catch ex
      return Fail("Evaluation in Julia failed.", ex, catch_backtrace())
   end
end


function evaluate!(call::Call, communicator::CommunicatoR)
   # evaluate arguments
   evaluate!(call.args, communicator)

   # the actual function call
   Base.invokelatest(call.fun,
         call.args.positionalelements...; call.args.namedelements...)
end


function evaluate!(list::ElementList, communicator::CommunicatoR)
   # recursively evaluate sub-elements first
   for i in eachindex(list.positionalelements)
      list.positionalelements[i] =
            evaluate!(list.positionalelements[i], communicator)
   end
   for name in list.names
      list.namedelements[name] =
            evaluate!(list.namedelements[name], communicator)
   end

   jltype = get(list.attributes, "JLTYPE", "")
   if !isempty(jltype)
      constructor = findfield(jltype)
      if length(list.names) > 0
         if constructor <: AbstractDict
            return Base.invokelatest(constructor, zip(
                  list.namedelements[:keys],
                  list.namedelements[:values]))
         elseif constructor <: NamedTuple
            return NamedTuple{Tuple(list.names)}(
                  [list.namedelements[name] for name in list.names])
         elseif constructor <: Module
            return Module(Symbol(list.namedelements[:name]))
         elseif constructor <: CircularReference
            error("Circular references cannot be reconstructed")
         else
            return reconstruct_struct(constructor, list, communicator)
         end
      else
         if constructor <: Tuple
            return Base.invokelatest(constructor, list.positionalelements)
         else
            # array type (or AbstractSet)
            return reconstruct_array(constructor, list.positionalelements,
                  list.attributes)
         end
      end
   elseif get(list.attributes, "IS_DF", false)
      return RDataFrame(list)
   elseif isempty(list.namedelements)
      return converttomostspecifictype(list.positionalelements)
   else
      return list
   end
end


function evaluate!(objref::ObjectReference, communicator::CommunicatoR)
   getobj(obj::ImmutableObjectReference) = obj.obj
   getobj(obj) = obj

   try
      obj = sharedheapget(communicator, objref)
      return getobj(obj)
   catch ex
      error("Object reference " * string(objref.ref, base = 16) *
            " could not be resolved")
   end
end


function evaluate!(item, communicator::CommunicatoR)
   item
end


""" Evaluates Julia code, passed as String, in the Main module """
function maineval(str::AbstractString)
   Main.eval(Meta.parse(str))
end


function mainevalcmd(str::String)
   if isempty(str)
      return nothing
   end
   strippedstr = strip(str)
   ret = include_string(Main, str)
   if strippedstr[end] == ';'
      return nothing
   else
      return ret
   end
end


"""
    mainevallet(str; ...)
Evalutes the string as the body of a let expression with the given
keyword arguments as variables in the let expression.
"""
function mainevallet(str::String; kwargs...)
   # Enclose str with a let block containing the kwargs

   # prevent the creation of a toplevel-Expression in Meta.parse
   str = "begin " * str * " end"

   if !isempty(kwargs)
      e = Expr(:let,
            Expr(:block,
                  [Expr(:(=), key, value) for (key, value) in kwargs]...),
            Expr(:block, Meta.parse(str)))
   else
      e = Expr(:let, Expr(:block), Expr(:block, Meta.parse(str)))
   end
   Main.eval(e)
end


function reconstruct_array(constructor, arr::Vector, attributes)
   if haskey(attributes, "JLDIM")
      return reconstruct_multidimensional_array(constructor,
            arr, attributes["JLDIM"])
   elseif any(isequal(JLUNDEF()), arr)
      ret = Base.invokelatest(constructor, undef, size(arr))
      copy_defined!(ret, arr)
      return ret
   else
      return Base.invokelatest(constructor, arr)
   end
end


function reconstruct_multidimensional_array(constructor, arr::Vector,
         dims::Vector{Int})

   if prod(dims) != length(arr)
      error("Incorrect dimensions of array. Dimensions are" *
            " $dims but number of elements is $(length(arr)).\n" *
            " If the array has been modified, the attribute \"JLDIM\"" *
            " (and perhaps the attribute \"JLTYPE\") must be set accordingly.")
   else
      ret = Base.invokelatest(constructor, undef, dims...)
      copy_defined!(ret, arr)
      return ret
   end
end


function reconstruct_struct(constructor, list::ElementList, communicator::CommunicatoR)
   # normal composite type:
   # forge call to inner constructor (which may be private)
   constructorargs = [list.namedelements[name] for name in list.names]
   obj = Main.eval(Expr(:new, constructor, [:($arg) for arg in constructorargs]...))

   # The reconstructed object may depend on a pre-existing copy and its resources.
   # This is referenced by the "JLREF" attribute.
   jlref::UInt64 = get(list.attributes, "JLREF", UInt64(0))
   if jlref != 0
      sharedfinalizer(communicator, obj, jlref)
   end

   return obj
end

struct CircularReference
   objref::UInt64
end


mutable struct SharedObject
   obj::Any
   refcount::UInt64
end

function SharedObject(obj)
   SharedObject(obj, UInt32(1))
end


# Encapsulate the io stream and a lock to prevent concurrent writing
# by multiple Tasks because this would mess up the messages
# Making the struct mutable makes it easier to share the object with R,
# as it always has a fixed address
mutable struct CommunicatoR{T}
   # the iostream for communicating with R
   io::T

   # for synchronizing the communication
   # (stderr and stdout are communicated asynchronously to evaluation)
   io_lock::ReentrantLock

   # used to detect circular references
   objrefs::Set{UInt64}

   # for sharing references between Julia and R
   sharedheap::Dict{UInt64, SharedObject}

   # make sharedheap thread safe (needed due to asynchronicity of finalization)
   sharedheap_lock::ReentrantLock

   # whether the next translation is forced to be a full translation
   # in contrast to a mere passing of a reference
   full_translation::Bool

   # Contains identifiers of finalized callback functions.
   # These can be communicated to R to be removed there as well.
   finalized_callbacks::Vector{String}

   # contains callback functions and their corresponding identifiers
   # for the communication with R
   registered_callbacks::Dict{Function, String}

   # make changing finalized_callbacks and registered_callbacks thread safe
   # (needed due to asynchronicity of finalization)
   callbacks_lock::ReentrantLock
end

function CommunicatoR(io)
   CommunicatoR(
      io,
      ReentrantLock(),
      Set{UInt64}(),
      Dict{UInt64, SharedObject}(),
      ReentrantLock(),
      false,
      Vector{String}(),
      Dict{Function, String}(),
      ReentrantLock()
   )
end


function write_bin(c::CommunicatoR, x)
   write(c.io, x)
end


function read_bin(c::CommunicatoR, n::Int)
   ret = read(c.io, n)
   while length(ret) < n
      ret = [ret; read(c.io, length(ret) - n)]
   end
   ret
end


function read_byte(c::CommunicatoR)
   read(c.io, UInt8)
end


# GLOBAL variable nclients to count the number of clients that are connected
const nclients = Ref{Int}(0)
const nclients_lock = ReentrantLock()

function inc_nclients()
   lock(nclients_lock)
   nclients.x += 1
   unlock(nclients_lock)
end

# decrement number of clients. Stop server if it is reduced to 0.
function dec_nclients()
   lock(nclients_lock)
   nclients.x -= 1
   if nclients.x <= 0
      exit(0)
   end
   unlock(nclients_lock)
end


"""
    serve(port_hint; keeprunnning = false, portfile = "")
Starts the JuliaConnectoR server, which will accept connections.

It is attempted to start the server at the port given via `port_hint`.
The actual port may be different. If the argument `portfile` is specified,
the real port is written to the file with the given name
as decimal number in form of a string.

If the argument `multiclient` is `false`,
the server accepts only one client and stops after the client disconnects.
If the argument `multiclient` is set to `true`,
the server will accept multiple clients and keeps running
after a client disconnects.
Note that multiple clients share the same global workspace.
"""
function serve(port_hint::Int;
      multiclient::Bool = false,
      portfile::String = "")

   realport, server = listenany(port_hint)
   println("Julia is listening on port $realport.")
   # write real port to portfile
   if (portfile != "")
      open(portfile, "w") do f
         write(f, string(Int(realport)))
         write(f, '\n')
      end
   end

   # Prevents crash when run as script and interrupted
   ccall(:jl_exit_on_sigint, Cvoid, (Cint,), 0)

   if multiclient
      while true
         sock = accept(server)
         @async serve_repl(sock)
         inc_nclients()
      end
   else
      sock = accept(server)
      # close(server) # don't listen for other clients
      # (not used because then listenany will re-use the same port)
      serve_repl(sock)
   end
end


function serve_repl(sock)
   communicator = CommunicatoR(sock)
   capture_outputstreams(communicator)

   while isopen(sock)
      call = Call()
      try
         firstbyte = read_bin(communicator, 1)
         if length(firstbyte) == 1 && firstbyte[1] == CALL_INDICATOR
            # Parse incoming function call
            call = read_call(communicator)
         else
            if !(length(firstbyte) == 0 || firstbyte[1] == BYEBYE)
               close(sock)
               error("Unexpected leading character $(firstbyte[1])")
            else
               close(sock)
               dec_nclients()
               return
            end
         end
      catch ex
         @warn "Unexpected parsing error. Stopping listening. " *
               "Original error: $ex"
         dec_nclients()
         return
      end

      result = evaluate_checked!(call, communicator)
      write_message(communicator, result)
   end

   dec_nclients()
end


function callbackfun(callbackid::String, communicator::CommunicatoR)

   callbackfinalizer = CallbackFinalizer(callbackid, communicator)

   ret = (args...; kwargs...) -> begin
      stayalivewithme(callbackfinalizer)

      posargs = isempty(args) ? Vector{Any}() : collect(Any, args)
      callbackargs = ElementList(posargs, Dict{Symbol, Any}(kwargs))
      write_callback_message(communicator, callbackid, callbackargs)

      # read, parse and return answer
      while true
         firstbyte = read_bin(communicator, 1)[1]
         if firstbyte == RESULT_INDICATOR
            answer = read_element(communicator)
            parsingcheck(answer)
            return evaluate!(answer, communicator)
         elseif firstbyte == CALL_INDICATOR
            call = read_call(communicator)
            result = evaluate_checked!(call, communicator)
            write_message(communicator, result)
         elseif firstbyte == FAIL_INDICATOR
            r_errormsg = read_string(communicator)
            error("Error in R callback: " * r_errormsg)
         else
            error("Unexpected leading byte: " * string(firstbyte))
         end
      end
   end

   register_callback(communicator, ret, callbackid)
   ret
end


function callanonymous(communicator::CommunicatoR, functionref::Vector{UInt8},
      args...; kwargs...)

   ref = parseheapref(functionref)
   objref::ImmutableObjectReference = sharedheapget(communicator, ref)
   f::Function = objref.obj
   ret = f(args...; kwargs...)
   ret
end


function start_result_message(c::CommunicatoR)
   # Ensure that output is transferred before the result:
   # Let the tasks redirecting the outputstreams take over
   # (see function redirect_outputstream)
   flush(c.io)
   flush(stdout)
   yield()
   flush(stderr)
   yield()

   # after the output is handled,
   # take control of the outputstream to send the result
   lock(c.io_lock)
end

start_fail_message = start_result_message
start_callback_message = start_result_message


function end_result_message(c::CommunicatoR)
   # end of circular reference detection
   empty!(c.objrefs)

   # release lock of outputstream for next call
   unlock(c.io_lock)
end

end_fail_message = end_result_message
end_callback_message = end_result_message


function start_output_message(c::CommunicatoR)
   lock(c.io_lock)
end


function end_output_message(c::CommunicatoR)
   unlock(c.io_lock)
end


function capture_outputstreams(communicator::CommunicatoR)
   redirect_outputstream(communicator, redirect_stdout()[1], STDOUT_INDICATOR)
   rd, wr = redirect_stderr()

   # Also redirect the logger.
   global_logger(SimpleLogger(wr))
   # For debugging, comment out the line above, use @debug lines and
   # set the environment variable "JULIA_DEBUG" to "all", e. g. in PowerShell
   # $env:JULIA_DEBUG = "all".
   # Start Julia and execute:
   # `import Tables; include("inst/Julia/RConnector.jl"); RConnector.serve(11980)`
   # Set the environment variable JULIACONNECTOR_SERVER=localhost:11980
   # for the R session. Then start R and load the JuliaConnectoR.
   # If you execute commands, debugging info is displayed on the command line.

   redirect_outputstream(communicator, rd, STDERR_INDICATOR)
end


# Starts an asynchronous task that sends the output to R
function redirect_outputstream(communicator::CommunicatoR, reader,
      output_type_indicator::UInt8)

   @async while isopen(communicator.io) && isopen(reader)
      iobuffer = readavailable(reader)
      write_output_message(communicator, iobuffer, output_type_indicator)
   end
end


function write_output_message(communicator::CommunicatoR, msg::Vector{UInt8},
      output_type_indicator::UInt8)

   start_output_message(communicator)
   write_bin(communicator, output_type_indicator)
   write_bin(communicator, Int32(length(msg)))
   write_bin(communicator, msg)
   end_output_message(communicator)
end


const DEFAULT_DISPLAY_LINES = 24
const DEFAULT_DISPLAY_COLUMNS = 80

function showobj(x, width::Int)
   io = IOBuffer()
   displaysize = (DEFAULT_DISPLAY_LINES, width)
   context = IOContext(io, :limit => true, :displaysize => displaysize)
   show(context, "text/plain", x)
   String(take!(io))
end

function showobj(x, width)
   try
      intwidth = convert(Int, width)
   catch ex
      intwidth = DEFAULT_DISPLAY_COLUMNS
   end
   showobj(x, width)
end

function write_message(communicator, result)
   start_result_message(communicator)
   write_bin(communicator, RESULT_INDICATOR)
   write_element(communicator, result)
   end_result_message(communicator)
end

function write_message(communicator, fail::Fail)
   start_fail_message(communicator)
   write_bin(communicator, FAIL_INDICATOR)
   write_string(communicator, fail.message)
   end_fail_message(communicator)
end


function write_callback_message(communicator, callbackid::String, args::ElementList)
   start_callback_message(communicator)
   write_bin(communicator, CALL_INDICATOR)
   write_string(communicator, callbackid)
   write_list(communicator, args)
   end_callback_message(communicator)
end


# attributes must be an iterable collection of keys (strings) and values.
function write_attributes(communicator, attributes)
   write_nattributes(communicator, length(attributes))
   for (key, value) in attributes
      write_string(communicator, key)
      write_element(communicator, value)
   end
end


function write_int32(communicator, i::Int)
   write_bin(communicator, Int32(i))
end

function write_int32s(communicator, intarr::Array{Int})
   for i in intarr
      write_int32(communicator, i)
   end
end

function write_nattributes(communicator, nattributes::Int)
   write_bin(communicator, convert(UInt8, nattributes))
end

function write_string(communicator, str::String)
   write_int32(communicator, ncodeunits(str))
   write_bin(communicator, str)
end

function write_dimensions(communicator, arr::AbstractArray)
   dims = size(arr)
   write_int32(communicator, length(dims))
   write_int32s(communicator, collect(dims))
end


function write_element(communicator, arr::Array{String}, attributes = ())
   write_bin(communicator, TYPE_ID_STRING)
   write_dimensions(communicator, arr)
   for i in eachindex(arr)
      if isassigned(arr, i)
         write_string(communicator, arr[i])
      else
         write_string(communicator, "")
      end
   end
   write_attributes(communicator, attributes)
end

function write_element(communicator, arr::Array{Union{String, Missing}})
   missings = findall(ismissing, vec(arr))
   arr2 = copy(arr)
   arr2[missings] .= ""
   strarr = convert(Array{String}, arr2)
   attributes = (("NA", missings), )
   write_element(communicator, strarr, attributes)
end

function write_element(communicator, arr::Array{F}) where {F <: SEND_AS_DOUBLE}
   attributes = (("JLTYPE", string(F)), )
   write_element(communicator, convert(Array{Float64}, arr), attributes)
end

function write_element(communicator, arr::Array{Union{Missing,F}}
      ) where {F <: Union{SEND_AS_DOUBLE}}
   attributes = (("JLTYPE", "Union{Missing," * string(F)* "}"), )
   arr2 = replace(arr, missing => R_NA_REAL)
   write_element(communicator, arr2, attributes)
end

function write_element(communicator, arr::Array{Union{Missing,Float64}})
   arr2 = replace(arr, missing => R_NA_REAL)
   write_element(communicator, arr2)
end

function write_element(communicator, arr::Array{Float64}, attributes = ())
   write_bin(communicator, TYPE_ID_FLOAT64)
   write_dimensions(communicator, arr)
   for f in arr
      write_bin(communicator, f)
   end
   write_attributes(communicator, attributes)
end

function write_uint8array_element(communicator, arr::AbstractArray{UInt8},
      attributes = ())

   if length(arr) == 1
      attributes = tuple(attributes..., ("JLDIM", 1))
   end

   write_bin(communicator, TYPE_ID_RAW)
   write_dimensions(communicator, arr)
   for d in arr
      write_bin(communicator, d)
   end
   write_attributes(communicator, attributes)
end

function write_element(communicator, arr::Array{UInt8}, attributes = ())
   write_uint8array_element(communicator, arr, attributes)
end

function write_element(communicator, arr::Array{T},
      ) where {T <: SEND_AS_INT32}

   attributes = (("JLTYPE", string(T)), )
   write_element(communicator, convert(Array{Int32}, arr), attributes, true)
end

function write_element(communicator, arr::Array{Union{Missing, T}},
      ) where {T <: Union{Int32, SEND_AS_INT32}}

   attributes = (("JLTYPE", "Union{Missing," * string(T)* "}"), )
   arr2 = convert(Array{Int32}, replace(arr, missing => R_NA_INTEGER))
   write_element(communicator, arr2, attributes, true)
end

function write_element(communicator, arr::Array{Int32},
      attributes = (), isothertype::Bool = false)

   if !isothertype
      attributes = (("JLTYPE", "Int32"), )
   end

   if length(arr) == 1
      attributes = tuple(attributes..., ("JLDIM", 1))
   end

   write_bin(communicator, TYPE_ID_INT)
   write_dimensions(communicator, arr)
   for i in arr
      write_bin(communicator, i)
   end
   write_attributes(communicator, attributes)
end

function write_element(communicator, arr::Array{Int64}; missings = Int[])

   arrmin, arrmax = extrema(arr)
   if arrmin >= typemin(Int32) && arrmax <= typemax(Int32)
      @static if Int == Int64
         attributes = ()
      else
         attributes = (("JLTYPE", "Int64"), )
      end
      if !isempty(missings)
         @static if Int != Int64
            attributes = (("JLTYPE", "Union{Missing,Int64}"), )
         end
         arr[missings] .= R_NA_INTEGER
      end
      write_element(communicator, convert(Array{Int32}, arr),
            attributes, true)
   else
      attributes = (("JLTYPE", "Int64"), )
      arr2 = convert(Array{Float64}, arr)
      if !isempty(missings)
         attributes = (("JLTYPE", "Union{Missing,Int64}"), )
         arr2[missings] .= R_NA_REAL
      end
      write_element(communicator, arr2, attributes)
      #TODO possible inexactness?
   end
end

function write_element(communicator, arr::Array{Union{Missing, Int64}})
   write_element(communicator, replace(arr, missing => 0);
         missings = findall(ismissing, arr))
end

function write_element(communicator, arr::Array{T},
      ) where {T <: SEND_AS_RAW_TYPES}

   if length(arr) == 1
      attributes = (("JLTYPE", string(T)), ("JLDIM", collect(size(arr))))
   else
      attributes = (("JLTYPE", string(T)), )
   end
   write_uint8array_element(communicator, reinterpret(UInt8, arr), attributes)
end

function write_element(communicator, arr::Array{Complex{Float64}},
      attributes = ())

   if length(arr) == 1
      attributes = tuple(attributes..., ("JLDIM", 1))
   end

   write_bin(communicator, TYPE_ID_COMPLEX)
   write_dimensions(communicator, arr)
   for d in arr
      write_bin(communicator, real(d))
      write_bin(communicator, imag(d))
   end
   write_attributes(communicator, attributes)
end

function write_element(communicator,
      arr::Array{Union{Missing,Complex{Float64}}})

   arr2 = replace(arr, missing => R_NA_COMPLEX)
   write_element(communicator, arr2)
end

function write_element(communicator, arr::Array{Union{Missing,C}},
      ) where {C <: SEND_AS_COMPLEX}

   arr2 = replace(arr, missing => R_NA_COMPLEX)
   attributes = (("JLTYPE", "Union{Missing," * string(C) * "}"), )
   write_element(communicator, arr2, attributes)
end

function write_element(communicator, arr::Array{C},
      ) where {C <: SEND_AS_COMPLEX}

   attributes = (("JLTYPE", string(C)), )
   write_element(communicator, convert.(Complex{Float64}, arr), attributes)
end

function write_element(communicator, arr::Array{Bool})
   write_bin(communicator, TYPE_ID_BOOL)
   write_dimensions(communicator, arr)
   for d in arr
      write_bin(communicator, d)
   end
end

function write_element(communicator, arr::Array{Union{Missing,Bool}})
   arr2 = replace(arr, true => Int32(1), false => Int32(0),
         missing => R_NA_INTEGER)
   attributes = (("R_LOGICAL", true), )
   write_element(communicator, arr2, attributes, true)
end

function write_array_element(communicator, arr::AbstractArray)

   attributes = Dict{String, Any}("JLTYPE" => string(typeof(arr)))

   arrsize = size(arr)

   arr2 = arr[:] # R lists support only 1 dimension
   if length(arrsize) > 1
      # we have a multidimensional array:
      # add the dimensions as attribute to be able to reconstruct it
      attributes["JLDIM"] = collect(arrsize)
   end

   ellist = ElementList(undefs_replaced(arr2), Vector{Symbol}(),
         Dict{Symbol, Any}(), attributes)
   write_element(communicator, ellist)
end

function write_element(communicator, arr::Array)
   if communicator.full_translation
      write_array_element(communicator, arr)
   else
      write_object_reference(communicator, arr, OBJECT_CLASS_ID_ARRAY)
   end
end

function write_element(communicator, arr::AbstractArray)
   if communicator.full_translation
      # translate as struct because you can never be sure of the implementation
      write_struct_element(communicator, arr)
   else
      # allow indexing as an array
      write_object_reference(communicator, arr, OBJECT_CLASS_ID_ARRAY)
   end
end

function write_element(communicator, dict::AbstractDict)

   if communicator.full_translation
      # Assure that keys and values are always in a list,
      # to allow a straightforward reconstruction later on.
      # Strings and numbers would otherwise be converted to vectors in R.
      alwaysaslist(x) = x
      alwaysaslist(x::Array{N}) where {N <: Union{Number, String}} =
            ElementList(Vector{Any}(x))

      ellist = ElementList(Vector{Any}(),
            [:keys, :values],
            Dict{Symbol, Any}(:keys => alwaysaslist(collect(keys(dict))),
                  :values => alwaysaslist(collect(values(dict)))),
            Dict{String, Any}("JLTYPE" => string(typeof(dict))))
      write_element(communicator, ellist)
   else
      write_object_reference(communicator, dict, OBJECT_CLASS_ID_STRUCT)
   end
end

function write_element(communicator, set::AbstractSet)
   if communicator.full_translation
      ellist = ElementList(Vector{Any}(collect(set)),
            Vector{Symbol}(), Dict{Symbol, Any}(),
            Dict{String, Any}("JLTYPE" => string(typeof(set))))
      write_element(communicator, ellist)
   else
      write_object_reference(communicator, set, OBJECT_CLASS_ID_STRUCT)
   end
end

function write_element(communicator, f::Function)

   callbackid = funtocallbackid(communicator, f)
   if callbackid == "" # it's not a callback function
      f_as_string = string(f)
      if endswith(f_as_string, "()") || startswith(f_as_string, '#')
         # Detected an anonymous function:
         # An anonymous function will have a string representation like
         # "getfield(Main, Symbol(\"##5#6\"))()" in Julia 1.0.
         # In Julia 1.3 it is something like "#3".
         ref = share_immutable_object!(communicator, f)
         write_bin(communicator, TYPE_ID_OBJECT_REFERENCE)
         write_bin(communicator, OBJECT_CLASS_ID_ANONYMOUS_FUNCTION)
         write_bin(communicator, ref)
         return

      else # Write an element for a named function.

         # In 1.0 f_as_string contains the full path, in 1.3 only the name.
         # We need the full path.
         # For operators, this does not work, because parsing fails then.
         if !('.' in f_as_string) && !Base.isoperator(Symbol(f_as_string))
            firstmodulepath = string(iterate(methods(f))[1].module)
            f_as_string = firstmodulepath * "." * f_as_string
         end

         write_bin(communicator, TYPE_ID_NAMED_FUNCTION)
         write_string(communicator, f_as_string)
         return
      end
   end

   write_bin(communicator, TYPE_ID_CALLBACK)
   write_string(communicator, callbackid)
end

function write_element(communicator, t::Tuple)
   if communicator.full_translation
      write_bin(communicator, TYPE_ID_LIST)
      attributes = Dict{String, Any}("JLTYPE" => string(typeof(t)))
      ellist = ElementList(
            Vector{Any}(collect(t)),
            Vector{Symbol}(), Dict{Symbol, Any}(),
            attributes)
      write_list(communicator, ellist)
   else
      write_object_reference(communicator, t, OBJECT_CLASS_ID_ARRAY)
   end
end

function write_element(communicator, ellist::ElementList)
   write_bin(communicator, TYPE_ID_LIST)
   write_list(communicator, ellist)
end

function write_element(communicator, obj::Symbol)
   write_bin(communicator, TYPE_ID_SYMBOL)
   write_string(communicator, string(obj))
end

function write_element(communicator, obj::Module)
   modulename = string(obj)
   if startswith(modulename, "Main.")
      modulename = String(modulename[6:end])
   end
   ellist = ElementList(
      Vector{Any}(),
      [:name],
      Dict{Symbol, Any}(:name => modulename),
      Dict{String, Any}("JLTYPE" => "Module"))
   write_element(communicator, ellist)
end

function write_element(communicator, obj::NamedTuple)
   if communicator.full_translation
      write_struct_element(communicator, obj)
   else
      write_object_reference(communicator, obj, OBJECT_CLASS_ID_STRUCT)
   end
end

function write_element(communicator, d::T) where {T2, T <: Type{T2}}
   write_expression(communicator, string(d))
end

function write_struct_element(communicator, obj::T,
      attributes::Dict{String, Any} = Dict{String, Any}()) where T

   names = fieldnames(T)
   if isempty(names) # type without members
      write_expression(communicator, string(T) * "()")
   else
      write_bin(communicator, TYPE_ID_LIST)
      fieldvalues = map(name -> getfield(obj, name), names)
      attributes["JLTYPE"] = string(T)
      ellist = ElementList(
            Vector(), collect(names),
            Dict{Symbol, Any}(zip(names, fieldvalues)),
            attributes)
      write_list(communicator, ellist)
   end
end

function write_mutable_struct_element(communicator, obj::T) where T

   ref = share_mutable_object!(communicator, obj)
   refexists = ref in communicator.objrefs
   push!(communicator.objrefs, ref)

   if refexists # recursion detected
      decrefcount!(communicator, ref) # not shared, actually
      write_struct_element(communicator, CircularReference(ref),
            Dict{String, Any}())
      return
   else
      # write object, giving reference to original object
      write_struct_element(communicator, obj,
            Dict{String, Any}("JLREF" => ref))
      return
   end
end

function write_element(communicator, obj::T) where T

   if isstructtype(T)
      if communicator.full_translation
         if !isimmutable(obj)
            write_mutable_struct_element(communicator, obj)
         else
            write_struct_element(communicator, obj)
         end
      else
         write_object_reference(communicator, obj, OBJECT_CLASS_ID_STRUCT)
      end
   else
      write_struct_element(communicator,
            Fail("Lost in translation: $(string(obj))"))
   end
end

function write_element(communicator, f::F) where {F <: SEND_AS_DOUBLE}
   attributes = (("JLTYPE", string(F)), )
   write_element(communicator, Float64(f), attributes)
end

function write_element(communicator, m::Missing)
   write_element(communicator, R_NA_REAL)
end

function write_element(communicator, m::Array{Missing})
   write_element(communicator, fill(R_NA_REAL, size(m)))
end

function write_element(communicator, f::Float64, attributes = ())
   write_bin(communicator, TYPE_ID_FLOAT64)
   write_int32(communicator, 0)
   write_bin(communicator, f)
   write_attributes(communicator, attributes)
end

function write_element(communicator, i::T) where {T <: SEND_AS_INT32}
   attributes = (("JLTYPE", string(T)), )
   write_element(communicator, Int32(i), attributes, true)
end

function write_element(communicator, i::Int32,
      attributes = (), isothertype::Bool = false)

   if !isothertype
      attributes = (("JLTYPE", "Int32"), )
   end

   write_bin(communicator, TYPE_ID_INT)
   write_int32(communicator, 0)
   write_bin(communicator, i)
   write_attributes(communicator, attributes)
end

function write_element(communicator, i::Int64)
   if typemin(Int32) <= i <= typemax(Int32)
      @static if Int == Int64
         attributes = ()
      else
         attributes = (("JLTYPE", "Int64"), )
      end
      write_element(communicator, Int32(i), attributes, true)
   else
      attributes = (("JLTYPE", "Int64"), )
      # TODO inexactness?
      write_element(communicator, Float64(i), attributes)
   end
end

function write_element(communicator, i::T) where {T <: SEND_AS_RAW_TYPES}
   attributes = (("JLTYPE", string(T)), )
   write_uint8array_element(communicator, reinterpret(UInt8, [i]), attributes)
end

function write_element(communicator, b::Bool)
   write_bin(communicator, TYPE_ID_BOOL)
   write_int32(communicator, 0)
   write_bin(communicator, b)
end

function write_element(communicator, str::String)
   write_bin(communicator, TYPE_ID_STRING)
   write_int32(communicator, 0)
   write_string(communicator, str)
   write_bin(communicator, 0x00) # no attributes
end

function write_element(communicator, c::Complex{Float64}, attributes = ())
   write_bin(communicator, TYPE_ID_COMPLEX)
   write_int32(communicator, 0)
   write_bin(communicator, Float64(real(c)))
   write_bin(communicator, Float64(imag(c)))
   write_attributes(communicator, attributes)
end

function write_element(communicator, c::C) where {C <: SEND_AS_COMPLEX}
   attributes = (("JLTYPE", string(C)), )
   write_element(communicator, convert(Complex{Float64}, c), attributes)
end

function write_element(communicator, u::UInt8)
   write_bin(communicator, TYPE_ID_RAW)
   write_int32(communicator, 0)
   write_bin(communicator, u)
   write_bin(communicator, 0x00) # no attributes
end

function write_element(communicator, n::Nothing)
   write_bin(communicator, TYPE_ID_NOTHING)
end

function write_element(communicator, p::EnforcedProxy{T}) where {T <: Array}
   write_object_reference(communicator, p.obj, OBJECT_CLASS_ID_SIMPLE_ARRAY)
end

function write_element(communicator, p::EnforcedProxy)
   write_object_reference(communicator, p.obj, OBJECT_CLASS_ID_NO_INFO)
end

function write_element(communicator, df::RDataFrame)
   if communicator.full_translation
      write_bin(communicator, TYPE_ID_LIST)
      write_list(communicator, getfield(df, :ellist))
   else
      write_object_reference(communicator, df, OBJECT_CLASS_ID_STRUCT)
   end
end

# This function and the struct serve only to communicate the CommunicatoR
# object of this client to R.
struct GetCommunicatoR
end
function write_element(communicator, _::GetCommunicatoR)
   ref = object_reference(communicator)
   write_object_reference(communicator, communicator, OBJECT_CLASS_ID_STRUCT)
end


function write_expression(communicator, str::AbstractString)
   write_bin(communicator, TYPE_ID_EXPRESSION)
   write_string(communicator, str)
end


function write_list(communicator, arr::AbstractArray)
   write_list(communicator, ElementList(vec(arr)))
end

function write_list(communicator, ellist::ElementList)
   write_int32(communicator, length(ellist.positionalelements))
   for el in ellist.positionalelements
      write_element(communicator, el)
   end

   write_int32(communicator, length(ellist.namedelements))
   for name in ellist.names # use the order of the names here
      write_string(communicator, string(name))
      write_element(communicator, ellist.namedelements[name])
   end

   write_attributes(communicator, ellist.attributes)
end


function write_object_reference(communicator, obj, object_class_id::UInt8)
   ref = shareobject!(communicator, obj)
   write_bin(communicator, TYPE_ID_OBJECT_REFERENCE)
   write_bin(communicator, object_class_id)
   write_bin(communicator, ref)
end

module StrangeNamesTest1
   export σ, ∇a
   σ(x) = 2*x
   *ₛ(x,y) = x*y
   const ∇a = Vector{Vector{Float64}}
   🚗(x) = "car" * x
end


module StrangeNamesTest2
   export σ
   σ(x) = 2*x
end


module StrangeNamesTest3
   σ(x) = 2*x
end


module StrangeNamesTest4
   export harmless1, harmless2, 🚗, 🚗🚗
   σ(x) = 2*x
   harmless1(x) = 17
   harmless2(x) = 17
   harmless3(x) = 17
   🚗(x) = "car" * x
   🚗🚗(x) = "carcar" * x
end


module StrangeNamesTest5
   export harmless1, 🚗
   🚗(x) = "car" * x
   harmless1(x) = 17
end

test_that("Julia names not expressible in R native encoding are identified", {
   if (grepl("testthat", getwd())) {
      testModulePath <- normalizePath("StrangeNamesTests.jl")
   } else {
      testModulePath <- normalizePath("tests/testthat/StrangeNamesTests.jl")
   }
   # Note: If the module is evaluated via juliaEval,
   # the native encoding is applied to the string,
   # which means e.g. that a sigma is translated to an "s".
   # Sadly this cannot be circumvented because
   # the transformation happens in the call to list(...) in juliaCall.

   juliaCall("include", testModulePath)

   if (l10n_info()$`UTF-8`) { #UTF-8 locale
      # This is not exactly the same as enc2native on a Windows machine with
      # "latin1" native encoding, but suffices to test the functions on Linux.
      transformation <- function(x) { iconv(x, to = "latin1", sub = "byte") }
   } else { # non-UTF8 locale
      transformation <- enc2native
   }

   juliaVersionGeq1_6 <- juliaEval('VERSION >= v"1.6-"')

   # strange: symbols that have a normal latex representation
   # very strange: no normal latex representation (emojis)
   testStrangeNames <- function(i,
                                nFunsExternal,
                                nStrangeFunsExternal,
                                nTypesExternal,
                                nStrangeTypesExternal,
                                nVeryStrangeInternal,
                                nVeryStrangeExternal,
                                nFunsInternal,
                                nStrangeFunsInternal,
                                nTypesInternal,
                                nStrangeTypesInternal) {

      if (juliaVersionGeq1_6) {
         # on Julia 1.6, now all symbols have a "latex" representation
         nVeryStrangeInternal <- 0
         nVeryStrangeExternal <- 0
      }

      moduleInfo <- juliaCall("RConnector.moduleinfo",
                              paste0("Main.StrangeNamesTest", i),
                              all = TRUE)

      if (l10n_info()$`UTF-8`) { #UTF-8 locale: no strange names
         theStrangeNames <- JuliaConnectoR:::strangeNames(moduleInfo)
         expect_equal(nrow(theStrangeNames), 0)
      }

      theStrangeNames <- JuliaConnectoR:::strangeNames(moduleInfo, transformation)
      nDefaultInternalFuns <- 2 # eval and include

      nVeryStrange <- nVeryStrangeExternal +
         nVeryStrangeInternal
      nStrange <- nStrangeTypesExternal + nStrangeTypesInternal +
         nStrangeFunsExternal + nStrangeFunsInternal
      nEscaped <- nStrange - nVeryStrange

      expect_equal(length(moduleInfo$escapedFunctions$escaped) +
                      length(moduleInfo$escapedTypes$escaped), nEscaped)
      expect_equal(length(moduleInfo$escapedFunctions$original) +
                             length(moduleInfo$escapedTypes$original), nEscaped)

      expect_equal(length(moduleInfo$exportedFunctions), nFunsExternal)
      expect_equal(length(moduleInfo$internalFunctions), nFunsInternal + nDefaultInternalFuns)
      expect_equal(length(moduleInfo$exportedTypes), nTypesExternal)
      expect_equal(length(moduleInfo$internalTypes), nTypesInternal)

      expect_warning({moduleInfo <- JuliaConnectoR:::removeStrangeNames(moduleInfo, transformation)})

      expect_equal(length(moduleInfo$escapedFunctions$escaped) +
                      length(moduleInfo$escapedTypes$escaped), nEscaped)
      expect_equal(length(moduleInfo$escapedFunctions$original) +
                      length(moduleInfo$escapedTypes$original), nEscaped)
      expect_equal(length(moduleInfo$exportedFunctions), nFunsExternal - nStrangeFunsExternal)
      expect_equal(length(moduleInfo$internalFunctions), nFunsInternal - nStrangeFunsInternal + nDefaultInternalFuns)
      expect_equal(length(moduleInfo$exportedTypes), nTypesExternal - nStrangeTypesExternal)
      expect_equal(length(moduleInfo$internalTypes), nTypesInternal - nStrangeTypesInternal)


      suppressWarnings({
         mAll <- juliaImport(paste0("Main.StrangeNamesTest", i), all = TRUE)})
      suppressWarnings({
         mExp <- juliaImport(paste0("Main.StrangeNamesTest", i), all = FALSE)})

      nFunsTotal <- nTypesExternal + nTypesInternal +
         nFunsInternal + nFunsExternal + nDefaultInternalFuns

      if (JuliaConnectoR:::nativeEncodingIsUtf8()) {

         expect_equal(length(names(mAll)), nFunsTotal + nEscaped)
         expect_equal(length(names(mExp)),
                      nTypesExternal + nFunsExternal +
                         nStrangeFunsExternal + nStrangeTypesExternal -
                         nVeryStrangeExternal)

         expect_equal(
            length(capture.output({
               JuliaConnectoR:::printEscapedAlternatives(attr(mAll, "moduleInfo"))
               })),
            nEscaped + 1)

         expect_match(capture.output({print(mAll)})[1],
                      paste(".*", nFunsTotal, "function.*"))

      } else {
         expect_equal(length(names(mAll)),
                      nTypesExternal + nTypesInternal +
                         nFunsInternal + nFunsExternal +
                         nDefaultInternalFuns -
                         nVeryStrange)
         expect_equal(length(names(mExp)),
                      nTypesExternal + nFunsExternal -
                         nVeryStrangeExternal)

         expect_equal(
            length(capture.output({
               JuliaConnectoR:::printEscapedAlternatives(attr(mAll, "moduleInfo"))
            })),
            nEscaped + 1)

         expect_match(capture.output({print(mAll)})[1],
                      paste(".*", nFunsTotal - nVeryStrange, "function.*"))
      }
   }

   testStrangeNames(1,
                    nFunsExternal = 1,
                    nStrangeFunsExternal = 1,
                    nTypesExternal = 1,
                    nStrangeTypesExternal = 1,
                    nVeryStrangeInternal = 1,
                    nVeryStrangeExternal = 0,
                    nFunsInternal = 2,
                    nStrangeFunsInternal = 2,
                    nTypesInternal = 0,
                    nStrangeTypesInternal = 0)


   testStrangeNames(2,
                    nFunsExternal = 1,
                    nStrangeFunsExternal = 1,
                    nTypesExternal = 0,
                    nStrangeTypesExternal = 0,
                    nVeryStrangeInternal = 0,
                    nVeryStrangeExternal = 0,
                    nFunsInternal = 0,
                    nStrangeFunsInternal = 0,
                    nTypesInternal = 0,
                    nStrangeTypesInternal = 0)

   testStrangeNames(3,
                    nFunsExternal = 0,
                    nStrangeFunsExternal = 0,
                    nTypesExternal = 0,
                    nStrangeTypesExternal = 0,
                    nVeryStrangeInternal = 0,
                    nVeryStrangeExternal = 0,
                    nFunsInternal = 1,
                    nStrangeFunsInternal = 1,
                    nTypesInternal = 0,
                    nStrangeTypesInternal = 0)

   testStrangeNames(4,
                    nFunsExternal = 4,
                    nStrangeFunsExternal = 2,
                    nTypesExternal = 0,
                    nStrangeTypesExternal = 0,
                    nVeryStrangeInternal = 0,
                    nVeryStrangeExternal = 2,
                    nFunsInternal = 2,
                    nStrangeFunsInternal = 1,
                    nTypesInternal = 0,
                    nStrangeTypesInternal = 0)

   testStrangeNames(5,
                    nFunsExternal = 2,
                    nStrangeFunsExternal = 1,
                    nTypesExternal = 0,
                    nStrangeTypesExternal = 0,
                    nVeryStrangeInternal = 0,
                    nVeryStrangeExternal = 1,
                    nFunsInternal = 0,
                    nStrangeFunsInternal = 0,
                    nTypesInternal = 0,
                    nStrangeTypesInternal = 0)
})

Sys.unsetenv("R_TESTS")


test_that("Some smoke tests", {
   expect_equal(juliaCall("prod", c(1,2,3)), 6)
   juliaEval("")
   juliaCall("string", list())
   juliaCall("string", list(as.integer(1), "bla" = 23L))
   juliaEval("String[]")
   expect(!is.null(juliaEval("using Random; Random.seed!(5)")),
          "Must be able to set random seed")
   expect(is.null(juliaEval("Random.seed!(5);")),
          "Eval with semicolon at end returns NULL")
})


test_that("Output is transferred", {
   output <- capture_output({
      juliaCall("println", as.integer(22))
   })
   expect_match(output, "^[\n]*22[\n]*$")

   output <- capture_output({
      juliaCall("println", "hello world")
   })
   expect_match(output, "^[\n]*hello world[\n]*$")
})


test_that("Warnings are transferred", {
   output <- capture.output(type = "message", {
      juliaEval('@warn "This might be serious"')
   })
   expect_match(output[1], "This might be serious")
})


test_that("Warnings and normal output are both transferred and stable", {
   stdoutput <- capture_output({
      stderroutput <- capture.output(type = "message", {
         juliaLet('for i = 1:100
                  println(join(rand(["1", "ä", "ö"], rand(1:100))));
                  println(stderr,join(rand(["2", "u", "a"], rand(1:100))));
                  end')
         ret <- juliaLet('println(22);  17')
      })
   })
   expect_match(stdoutput, "[1äö\n]+")
   expect_match(stderroutput, "[2ua\n]+") # TODO problems with non-ascii-characters


   stdoutput <- capture_output({
      stderroutput <- capture.output(type = "message", {
         ret <- juliaLet('println(22); @warn "This might be serious"; 17')
      })
   })
   expect_equal(ret, 17)
   expect_match(stdoutput[1], "^[\n]*22[\n]*$")
   expect_match(stderroutput[1], "This might be serious")
})


test_that("A return value of nothing is not printed", {
   output <- capture_output({
      juliaEval("nothing")
      juliaCall("identity", NULL)
      juliaLet("x = y", y = NULL)
   })
   expect_match(output, "^[\n]*$")
})


test_that("Test loading and importing a complex package", {
   skip_on_cran()
   juliaEval('begin
                 using Pkg;
                 try
                    @eval import StatsBase
                 catch ex
                    Pkg.add("StatsBase")
                 end
             end
             ') # tests also trailing whitespace
   StatsBase <- juliaImport("StatsBase")
   expect_equivalent(juliaGet(StatsBase$mean_and_var(c(1,2,3))), list(2,1))
   StatsBase$renyientropy(rnorm(100), 1)
})


test_that("Error when trying to import a non-existent package or module", {
   expect_error(juliaImport("NonExistingPkg"))
   expect_error(capture.output({juliaImport(".NonExistingModule")}, type = "message"))
})

test_that("Error when passing multiple strings to import or using", {
   expect_error(juliaImport(c("Pkg", "UUID")), regexp = "exactly one")
})


test_that("Example for juliaEval runs", {
   v1 <- juliaExpr('v"1.0.5"')
   v2 <- juliaExpr('v"1.3.0"')
   expect(juliaCall("<", v1, v2), "Comparison must work")
})


test_that("Echo: empty R vector", {testEcho(c())})


test_that("Echo: double", {
   expect(is.integer(juliaEcho(1L)), "Must be integer")
   testEcho(1L)
})


test_that("Echo: Single Int", {
   testEcho(1L)
   expect(is.integer(juliaEval("1")), "1 is not integer")
   testEcho(juliaEval("1"))
   expect(is.double(juliaEval("2^52")), "2^52 is not double") # TODO inexactness?
   testEcho(juliaEval("2^52"))
})
test_that("Echo: 1-element vector of Int in Julia", {testEcho(juliaEval("[1]"))})
test_that("Echo: Matrix of Int", {testEcho(matrix(1:6, nrow = 2))})


test_that("Echo: Single Float64", {
   testEcho(juliaEval("1.0"))
   testEcho(1)
})

test_that("UInt32, Float16, and Float32 translated to doubles in R", {
   toTest <- c("Float16(1.5)", "Float16[]", "Float16[1.5]",
               "Float32(1.5)", "Float32[]", "Float32[1.5]",
               "UInt32(32)", "UInt32[]", "UInt32[32]")
   for (expr in toTest) {
      expect(is.double(juliaEval(expr)), "Must be double")
   }
})

test_that("Echo: 0-element vector of Float64 in Julia", {testEcho(juliaEval("Float64[]"))})
test_that("Echo: 1-element vector of Float64 in Julia", {testEcho(juliaEval("[1.0]"))})
test_that("Echo: 2-element vector of Float64/double", {
   testEcho(c(1, 2))
   testEcho("[1.0; 2.0]")
})
test_that("Echo: matrix of Float64 in Julia", {
   testEcho(juliaEval("[1.0  2.0; 3.0 4.0]"))
   testEcho(matrix(c(1,2,3,4,4,5), nrow = 2))
})


test_that("Echo: 1-element vector of Float32 in Julia", {testEcho(juliaEval("[1.0f0]"))})
test_that("Echo: matrix of Float32 in Julia", {testEcho(juliaEval("[1.0f0  2.0f0; 3.0f0 4.0f0]"))})

test_that("Echo: 1-element vector of String in Julia", {testEcho(juliaEval('String["bla"]'))})
test_that("Echo: 0-element vector of String in Julia", {testEcho("String[]")})
test_that("Echo: 1-element vector of String in R", {testEcho("bla")})
test_that("Echo: 2-element vector of String in R", {testEcho(c("bla", "blup"))})
test_that("Echo: 2-element vector of String in Julia", {testEcho(juliaEval('String["bla", "blup"]'))})


test_that("Echo: String with missing values", {
   x <- c("Yes", "No", NA)
   y <- juliaEcho(x)
   expect_true(is.na(y[3]))

   x <- matrix(c("bla", NA, NA, "NA"), nrow = 2)
   y <- juliaEcho(x)
   expect_false(is.na(y[1,1]))
   expect_true(is.na(y[1,2]))
   expect_true(is.na(y[2,1]))
   expect_false(is.na(y[2,2]))
})


test_that("Echo: Int vector with missing values", {
   expect_true(juliaLet("x[1] == 1 && ismissing(x[2]) && x[3] == 3", x = c(1L,NA, 3L)))
   expect_true(juliaLet("ismissing(x)", x = NA_integer_))
   x <- juliaEval("[1 missing 3; 3 missing 4 ]")
   expect_type(x, "integer")
   expect_true(all(is.na(x[,2])))
   expect_null(attr(x, "JLTYPE"))

   x <- juliaEval("[2^52 missing 3; 2^53 missing 4 ]")
   expect_type(x, "double")
   expect_true(all(is.na(x[,2])))
   expect_equal(x[1,1], 2^52)
   expect_equal(x[2,1], 2^53)
   testEcho(x)

   x <- juliaEval("Union{Int32,Missing}[1 missing 3; 3 missing 4 ]")
   expect_type(x, "integer")
   expect_true(all(is.na(x[,2])))
   expect_equal(x[1,1], 1)
   expect_equal(x[2,1], 3)
   testEcho(x)

   x <- juliaEval("Union{Int16,Missing}[-1 missing 3; 3 missing 4 ]")
   expect_type(x, "integer")
   expect_true(all(is.na(x[,2])))
   expect_equal(x[1,1], -1)
   expect_equal(x[2,1], 3)
   testEcho(x)

   testEcho(c(1L, 2L, NA, NA))
   testEcho(matrix(c(1L, 2L, NA, NA), nrow = 2))
})


test_that("Echo: Double vector with missing values", {
   expect_true(juliaLet("x[1] == 1.0 && ismissing(x[2]) && x[3] == 3.0", x = c(1,NA, 3)))
   expect_true(juliaLet("ismissing(x)", x = NA_integer_))
   x <- juliaEval("[1.0 missing 3.0; 3.0 missing 4.0 ]")
   expect_type(x, "double")
   expect_true(all(is.na(x[,2])))
   expect_null(attr(x, "JLTYPE"))


   x <- juliaEval("Union{Float32,Missing}[1.0f0 missing 3.0f0; 3.0f0 missing 4.0f0 ]")
   expect_true(all(is.na(x[,2])))
   expect_equal(x[1,1], 1)
   expect_equal(x[2,1], 3)
   testEcho(x)

   testEcho(c(1, 2, NA, NA))
   testEcho(matrix(c(1, 2, NA, NA), nrow = 2))
})


test_that("Dirty missing values are recognized", {
   dirtyNa <- c(as.raw(0xa2), as.raw(0x07), as.raw(0x00), as.raw(0x00),
                as.raw(0x00), as.raw(0x00), as.raw(0xf8), as.raw(0x7f))
   dirtyNA <- readBin(dirtyNa, what = "double", endian = "little")
   expect_true(is.na(dirtyNA) && !is.nan(dirtyNA))
   expect_true(juliaCall("ismissing", dirtyNA))
   expect_true(juliaLet("ismissing(x[2])", x = c(1, dirtyNA)))
   echoDirtyNA <- juliaEcho(dirtyNA)
   expect_true(is.na(echoDirtyNA) && ! is.nan(echoDirtyNA))
   dirtyComplexNA <- complex(real = dirtyNA, imaginary = dirtyNA)
   expect_true(is.na(dirtyComplexNA) && !is.nan(dirtyComplexNA))
   expect_true(juliaCall("ismissing", dirtyComplexNA))
   x <- c(1+1i, dirtyComplexNA, NA)
   expect_true(juliaLet("ismissing(x[2]) && ismissing(x[3])", x = x))
   testEcho(x)
   # The following doesn't work: dirtNA coerced to NA+0i, not NA+NA*i:
   # expect_true(juliaLet("ismissing(x[2])", x = c(1+1i, dirtyNA)))
   echoDirtyComplexNA <- juliaEcho(dirtyComplexNA)
   expect_true(is.na(echoDirtyComplexNA) && !is.nan(echoDirtyComplexNA))
})


test_that("NaN and NA are handled differently", {
   # NaN in R is translated to a NaN Float64 value in Julia
   # NA in R is translated to a missing value in Julia

   x <- juliaEval("[1; missing; NaN]")
   expect_equal(x[1], 1)
   expect_true(is.na(x[2]) && !is.nan(x[2]))
   expect_true(is.nan(x[3]))

   y <- juliaEcho(x)
   expect_equal(y[1], 1)
   expect_true(is.na(y[2]) && !is.nan(y[2]))
   expect_true(is.nan(y[3]))

   expect_equal(juliaCall("typeof", c(1, NA)),
                juliaEval("Array{Union{Float64,Missing},1}"))
   expect_equal(juliaCall("typeof", c(1, NaN)),
                juliaEval("Array{Float64,1}"))

   expect_equal(juliaCall("typeof", c(1+1i, NA)),
                juliaEval("Array{Union{Complex{Float64},Missing},1}"))
   expect_equal(juliaCall("typeof", c(1+1i, NaN)),
                juliaEval("Array{Complex{Float64},1}"))

   expect_true(juliaLet("ismissing(x[2])", x = c(1+1i, NA)))
})


test_that("Missing values transferred as NA", {
   expect_true(is.na(juliaEval("missing")))
   expect_true(all(is.na(juliaEval("[missing; missing]"))))
   expect_true(all(is.na(juliaEval("[missing missing; missing missing]"))))
})

test_that("Logical with missing values", {
   juliaLet("x[1] && !x[2] && ismissing(x[3])", x = c(TRUE, FALSE, NA))
   x <- c(TRUE, FALSE, NA)
   testEcho(x)
})

test_that("Complex with missing values", {
   juliaLet("x[1] == 1+1im && x[2] == 2+2im && ismissing(x[3])", x = c(1 +1i, 2+2i, NA))
   x <- c(1 +1i, 2+2i, NA)
   testEcho(x)

   x <- juliaEval("[1+1im 1+2im; 0 missing]")
   expect_equivalent(x, matrix(c(1+1i, 0, 1+2i, NA), nrow = 2))
   testEcho(x)

   x <- juliaEval("[1.0+im 2.0+im; 0.0 missing]")
   expect_equal(x, matrix(c(1+1i, 0, 2+1i, NA), nrow = 2))
   expect_true(is.null(attr(x, "JLTYPE")))
   testEcho(x)
})


test_that("Echo: logical vectors", {
   testEcho(juliaEval('Bool[]'))
   testEcho(logical())
   testEcho(TRUE)
   testEcho(FALSE)
   testEcho(c(TRUE, FALSE))
   testEcho("Bool[true]")
})


test_that("Echo: Pointers", {
   arrPtr <- juliaFun("Base.pointer", list(1,2,3))
   ptr <- arrPtr(2L)
   expect_type(ptr, "raw")
   testEcho(ptr)
   ptrs <- juliaCall("map", arrPtr, as.integer(1:3))
   testEcho(ptrs)
})


test_that("Echo: Ref", {
   testEcho(juliaCall("Ref", list(1,2,3), 2L))
   r <- juliaEval("global reftestvar = 1; Ref(reftestvar)")
   testEcho(r)
})


test_that("Complex values are handled first class", {
   testEcho(1i)
   testEcho(juliaEval("1+im"))
   testEcho(juliaEval("[1+im]"))
   testEcho(juliaEval("[1+im; 2+im]"))
   testEcho(c(1+1i,2 + 2i))

   suppressWarnings({jla <- juliaImport("LinearAlgebra")})
   testEcho(matrix(c(1, 0, 0, -1), ncol = 2))
   expect(all(jla$eigvals(matrix(c(1, 0, 0, -1), ncol = 2),
                   matrix(c(0, 1, 1, 0), ncol = 2)) %in% c(1i, -1i)),
          "")
   expect(all(jla$eigmax(matrix(c(0, 1i, -1i, 0), ncol = 2)) == 1.0), "")

   complexTypeParameters = c("Int8", "Int16", "Int32", "Int64",
                             "Float16", "Float32", "Float64")
   for (complexPar in complexTypeParameters) {
      juliaComplexType <- paste0("Complex{", complexPar, "}")
      c <- juliaEval(paste0(juliaComplexType, "(5-3im)"))
      expect_equivalent(c, 5 - 3i)
      carr <- juliaEval(paste0(juliaComplexType, "[4+4im, 2-2im]"))
      expect_equivalent(carr, c(4+4i, 2-2i))
      if (complexPar == "Float64") {
         expect_null(attr(c, "JLTYPE"))
      } else {
         expect_true(juliaCall("==", juliaEval(attr(c, "JLTYPE")),
                               juliaEval(juliaComplexType)))
      }
   }
})


test_that("Echo: raw vector", {
   testEcho(as.raw(c(1,2,3)))
   testEcho(juliaEval("[0x01]"))
   testEcho(juliaEval("UInt8[]"))
   expect_equivalent(juliaEval("[0x01 0x02; 0x03 0x04]"),
                     matrix(c(1,3,2,4), nrow = 2))
   expect_equal(juliaCall("string", c(as.raw(0xca), as.raw(0xfe))),
                "UInt8[0xca, 0xfe]")
})


test_that("Echo: raw vector", {
   testEcho(juliaEval("Int32[1, 2]"))
   testEcho(juliaEval("Int32[]"))
   testEcho(juliaEval("Int32[1]"))
})


test_that("Echo: Single Int16", {testEcho(juliaEval('Int16(300)'))})
test_that("Echo: Int16 Vector", {testEcho(juliaEval('Int16[1,2,3]'))})
test_that("Echo: 1-element Int16 Vector", {
   expect_equal(juliaCall("string", juliaEval('Int16[300]')),
                "Int16[300]")
})


test_that("Echo: Single UInt128", {testEcho(juliaEval('UInt128(2)^100 +1'))})
test_that("Echo: UInt128 Vector", {testEcho(juliaEval('UInt128[1,2,3]'))})
test_that("Echo: 1-element UInt128 Vector", {
   expect_equal(juliaCall("string", juliaEval('UInt128[1]')),
                "UInt128[0x00000000000000000000000000000001]")
})


test_that("Echo: List with NULL elements", {
   x <- juliaGet(juliaEcho(list(1, NULL, 3)))
   expect_equal(x[[1]], 1)
   expect_null(x[[2]])
   expect_equal(x[[3]], 3)
   expect_equal(length(x), 3)
   testEcho(juliaEval('[1, nothing, 3]'))
   x <- list("bla", NULL)
   expect_equal(x[[1]], "bla")
   expect_null(x[[2]])
   x <- list(NULL, NULL)
   expect_null(x[[1]])
   expect_null(x[[2]])
})


test_that("Mutable struct usable by reference", {
   juliaEval('mutable struct TestMutableStruct
                x::Int
             end')
   jlRef <- juliaEval("TestMutableStruct(1)")
   refEcho <- juliaEcho(jlRef)
   expect_true(juliaCall("==", jlRef, refEcho))
   expect_true(all(get("ref", jlRef) == get("ref", refEcho)))
   expect_equal(refEcho$x, 1)
   refEcho$x <- 2L
   expect_equal(jlRef$x, 2)
   ref <- get("ref", jlRef)
   jlRef <- NULL
   refEcho <- NULL
   invisible(gc())
   juliaEval("1")
   expect_false(juliaLet("haskey(communicator.sharedheap, ref)", ref = ref,
                         communicator = JuliaConnectoR:::pkgLocal$communicator))

   # Test behaviuor with juliaGet:
   # The reference must be attached
   jlRefEnv <- attr(juliaGet(juliaEval("TestMutableStruct(1)")), "JLREF")
   expect_true(is.environment(jlRefEnv))
   expect_true(is.raw(jlRefEnv$ref))
})


test_that("Immutable struct usable by reference and translated", {
   juliaEval('struct TestImmutableStruct
                x::Int
             end')
   jlRef <- juliaEval("TestImmutableStruct(1)")
   expect_s3_class(jlRef, "JuliaStructProxy")
   refEcho <- juliaEcho(jlRef)
   expect_true(juliaCall("==", jlRef, refEcho))
   expect_equal(refEcho$x, 1)
   ref <- get("ref", jlRef)
   expect_equal(juliaGet(jlRef)$x, 1)
   expect_false(juliaLet("haskey(communicator.sharedheap, ref)", ref = ref,
                         communicator = JuliaConnectoR:::pkgLocal$communicator))
   gc()
   juliaEval("1")
})


test_that("Currying in juliaFun works", {
   plus1 <- juliaFun("+", 1)
   plus1(2)
   expect_equal(juliaCall("map", plus1, c(1,2,3)), c(2,3,4))
})


test_that("Multidimensional object arrays work", {
   juliaEval("struct MultiTestStruct
                f::Float64
              end")

   content <- juliaEval("rand(4,5,6)")
   testEcho(content)
   x <- juliaLet("map(MultiTestStruct, c)", c = content)
   testEcho(x)
   expect_equivalent(dim(x), c(4,5,6))

   expect_equivalent(juliaGet(x[1,1,1]), list(juliaGet(x[[1,1,1]])))

   x[[1,2,3]] <- juliaEval("MultiTestStruct(17.0)")
   expect_equal(x[[1,2,3]]$f, 17)

   x[1,2,2] <- juliaEval("MultiTestStruct(19.0)")
   expect_equal(x[[1,2,2]]$f, 19)

   x[1,2,2] <- list(juliaEval("MultiTestStruct(19.0)"))
   expect_equal(x[[1,2,2]]$f, 19)

   expect_equal(dim(x[3:4, 4:5, 1]), c(2,2,1))
   expect_equal(dim(x[3:4, as.integer(4:5), 1L]), c(2,2,1))

   x[3:4, as.integer(4:5), 1L] <- juliaEval("MultiTestStruct(20.0)")
   expect_equal(juliaGet(x[[3, 4, 1]])$f, 20)
   expect_equal(juliaGet(x[[4, 5, 1]])$f, 20)

   y <- juliaGet(x)
   attr(y, "JLDIM") <- c(1L, 2L, 3L)
   expect_error(juliaEcho(y), regexp = "Incorrect dimensions")

   # Must also work with dimensions of zero
   testEcho(juliaEval("Matrix{MultiTestStruct}(undef, 0, 0)"))

   x <- juliaEval("Array{MultiTestStruct}(undef, 0, 0, 0)")
   testEcho(x)
   expect_equivalent(dim(x), c(0,0,0))

   # Two dimensions
   content <- juliaEval("rand(2,3)")
   x <- juliaLet("map(MultiTestStruct, c)", c = content)
   x[[1,2]] <- juliaEval("MultiTestStruct(3.0)")
   expect_equal(x[[1,2]]$f, 3)
})


test_that("Arrays with undef entries are translated", {
   juliaEval("mutable struct MutableTestStruct
                f::Float64
             end")

   # all undefs
   testEcho(juliaEval("Vector{MutableTestStruct}(undef, 3)"),
            comparableInJulia = FALSE)

   # undefs and values
   juliaLet("x = Vector{MutableTestStruct}(undef, 3);
             x[1] = MutableTestStruct(x1);
             x[2] = MutableTestStruct(x2);
            x", x1 = 1.0, x2 = 2.0)
   testEcho(juliaEval("Vector{MutableTestStruct}(undef, 3)"),
            comparableInJulia = FALSE)

   # multidimensional arrays with undefs and values
   x <- juliaLet("x = Array{MutableTestStruct}(undef, 2, 3, 4);
             x[1,1,1] = MutableTestStruct(x1);
            x[2,2,2] = MutableTestStruct(x2);
            x", x1 = 1.0, x2 = 2.0)
   testEcho(x, comparableInJulia = FALSE)
   expect_equal(x[[1]]$f, 1)
})


test_that("Undefined strings are transferred as empty strings", {
   expect_equal(juliaEval("Vector{String}(undef, 3)"), c("", "", ""))
})


test_that("String with null can be translated back to Julia", {
   # einfacher string
   jlStrWithNul <- "String([0x48, 0x65, 0x6c, 0x6c, 0x6f, 0x00, 0x5a, 0x65, 0x72, 0x6f, 0x57])"
   str <- juliaEval(jlStrWithNul)
   expect_true(is.raw(str))
   expect_equal(as.character(juliaCall("typeof", str)), "String")
   expect_equal(as.character(juliaLet("String(x[1:5])", x = str)), "Hello")

   # string array

   strArr <- juliaLet("String[a,b]", a = str, b = str)
   expect_true(is.list(strArr))

   strArr <- juliaLet("String[a,b,c]", a = str, b = str, c = str)
   expect_true(is.list(strArr))
   expect_equal(juliaCall("typeof", strArr), juliaEval("Array{String,1}"))
})


# Test Let
test_that("Let: used like eval", {
   output <- capture_output({expect(is.null(juliaLet("print(1)")), "Failed")})
   expect_equal(output, "1")
})
test_that("Let: must error with no named argument", {expect_error(juliaLet("print(x)", 1), "")})
test_that("Let: basic echo", {expect(all(juliaLet("identity(x)", x=c(2, 3)) == c(2,3)), "Failed")})

test_that("Let: Simple example from documentation works", {
   expect_equal(capture_output({juliaLet('println(x)', x = 1)}),
                capture_output({juliaEval('let x = 1.0; println(x) end')}))
})

test_that("Let: arguments without names not accepted", {
   expect_error(juliaLet("println(1)", 1), regexp = "names")
   expect_error(juliaLet("println(1)", x=1, 1, y=2), regexp = "names")
})


#Test Pairs
test_that("Echo: Pairs", {
   testEcho(juliaEval("(1 => 2.0)"))
   testEcho(juliaEval("1 => 2.0 => 3.0"))
   testEcho(juliaEval("[1 => 2.0, 2 => 3.0]"))
})


# Test Tuples
test_that("Echo: Tuples", {
   x <- juliaEval("(1, 17, 18)")
   expect_equal(x[[2]], 17)
   expect_equal(juliaGet(x[1]), juliaGet(juliaEval("(1,)")))
   expect_length(x, 3)
   expect_length(x[1:2], 2)

   testEcho(juliaEval("(1, 2.0)"))
   testEcho(juliaEval("((1, 2.0), 3.0)"))
   testEcho(juliaLet("collect(zip(x,y))", x = c(1L,2L, 3L), y = c(1,0,1)))

   testEcho(juliaEval("(Ref(false), Ref(true))"))
   testEcho(juliaEval("Tuple{}()"))
})


# Test Named Tuples
test_that("Echo: Named Tuples", {
   namedTuple <- juliaLet("y=2*x; z = 3*u + 1; (x=y, y=z)", x=2, u=4)
   expect_s3_class(namedTuple, "JuliaStructProxy")
   expect_equal(namedTuple$y, 13)
   expect_type(juliaGet(namedTuple), "list")
   expect_equal(juliaGet(namedTuple)$y, 13)
   testEcho(namedTuple)
})


# Test Module
test_that("Echo: Module", {
   juliaEval("module TestModule end")
   testEcho(juliaEval("TestModule"))
})

test_that("Echo: Symbol", {
   x <- juliaEval(":asymbol")
   expect_true(is.symbol(x))
   expect_true(juliaCall("isa", as.symbol("s"), juliaExpr("Symbol")))
   testEcho(x)
})


# Test Dictionary
test_that("Echo: Dictionary", {
   d <- juliaEval("Dict(:bla => 1.0, :blup => 3.0)")
   expect_equivalent(d[juliaExpr(":bla")][[1]], 1)
   expect_equal(d[juliaExpr(":bla"), juliaExpr(":bla")], as.list(c(1, 1)))
   expect_equal(d[[as.symbol("bla")]], 1)
   expect_equal(d[as.symbol("blup")],list(3))
   d[juliaExpr(":blup")] <- 4
   expect_equal(d[[juliaExpr(":blup")]], 4)
   d[[juliaExpr(":blup")]] <- 5
   expect_equal(d[[juliaExpr(":blup")]], 5)
   d2 <- juliaGet(d)
   expect_setequal(d2[["keys"]], juliaGet(juliaEval("[:bla, :blup]")))
   expect_setequal(d2[["values"]], list(1, 5))

   d[juliaExpr(":hi"), juliaExpr(":hello")] <- c(15, 14)
   expect_equal(d[juliaExpr(":bla"), juliaExpr(":hi")], as.list(c(1, 15)))
   d[juliaExpr(":hi"), juliaExpr(":hello")] <- as.list(c(16, 17))
   expect_equal(d[juliaExpr(":bla"), juliaExpr(":hello"), juliaExpr(":hi")], as.list(c(1, 17, 16)))
   expect_length(d[juliaExpr(":bla"), juliaExpr(":hi"), juliaExpr(":hello"), juliaExpr(":hello")], 4)

   d <- juliaLet("Dict(zip(x, y))", x = c("bla", "blup"), y = c(1,2))
   expect_equal(d[["bla"]], 1)
   expect_equivalent(d["blup"], list(2))
   d2 <- juliaGet(d)
   expect_setequal(d2[["keys"]], list("bla", "blup"))
   expect_setequal(d2[["values"]], list(1, 2))

   d2 <- juliaGet(d)
   expect_setequal(d2[["keys"]], list("bla", "blup"))
   expect_setequal(d2[["values"]], list(1,2))

   d$bla <- 17
   expect_equal(d$bla, 17)

   d <- juliaLet("Dict(zip(x, y))", x = list("bla"), y = list(1))
   expect_equal(length(juliaCall("keys", d)), 1)
   testEcho(d)

   d <- juliaLet("Dict(zip(x, y))", x = list(), y = list())
   d2 <- juliaGet(d)
   expect_length(d2[["keys"]], 0)
   expect_length(d2[["values"]], 0)
   testEcho(d)
})


# Test Set
test_that("Echo: Set", {
   s1 <- juliaEval("Set([1; 2; 3; 4])")
   s2 <- juliaEval("Set([1; 2])")
   expect_length(setdiff(juliaGet(juliaEval("Set([1; 2; 3; 4])")),
                         c(1,2,3,4)), 0)
   expect_length(setdiff(juliaGet(juliaLet("setdiff(s1, s2)", s1 = s1, s2 = s2)),
                         c(3,4)), 0)
   testEcho(s1)
})


# Test types with bitstypes
test_that("Object with bitstype", {
   uuidregex <- '^[a-f0-9]{8}-?[a-f0-9]{4}-?4[a-f0-9]{3}-?[89ab][a-f0-9]{3}-?[a-f0-9]{12}$'
   UUIDs <- juliaImport("UUIDs")
   expect_match(juliaCall("string", UUIDs$uuid4()), uuidregex)
})


test_that("Exotic objects handled gracefully", {
   x <- quote(1 + 1)
   expect_type(x, "language")
   expect_warning({ y <- juliaEcho(list(x = x))},
                  regexp = "not translatable", all = FALSE)
   expect_null(y$x)
})


# Test complex constructor with all kinds of types
test_that("Complex Julia object with different member type", {
   juliaEval('struct TestTypeWithAllKindsOfStuff
               n::Nothing
               f16::Float16
               f32::Float32
               f64::Float64
               b::Bool
               i8::Int8
               ui8::UInt8
               i16::Int16
               ui16::UInt16
               i32::Int32
               ui32::UInt32
               ch::Char
               i64::Int64
               ui64::UInt64
               i128::Int128
               ui128::UInt128
               f16vec::Vector{Float16}
               f32vec::Vector{Float32}
               f64vec::Vector{Float64}
               bvec::Vector{Bool}
               i8vec::Vector{Int8}
               ui8vec::Vector{UInt8}
               i16vec::Vector{Int16}
               ui16vec::Vector{UInt16}
               i32vec::Vector{Int32}
               ui32vec::Vector{UInt32}
               chvec::Vector{Char}
               i64vec::Vector{Int64}
               ui64vec::Vector{UInt64}
               i128vec::Vector{Int128}
               ui128vec::Vector{UInt128}
             end')
   juliaEval('function TestTypeWithAllKindsOfStuff()
               TestTypeWithAllKindsOfStuff(
                     nothing,
                     rand(Float16), rand(Float32), rand(Float64),
                     rand(Bool),
                     rand(Int8), rand(UInt8),
                     rand(Int16), rand(UInt16),
                     rand(Int32), rand(UInt32),
                     rand(Char),
                     rand(Int64), rand(UInt64),
                     rand(Int128), rand(UInt128),
                     rand(Float16, 2), rand(Float32, 2), rand(Float64, 2),
                     rand(Bool, 2),
                     rand(Int8, 2), rand(UInt8, 2),
                     rand(Int16, 2), rand(UInt16, 2),
                     rand(Int32, 2), rand(UInt32, 2),
                     rand(Char, 2),
                     rand(Int64, 2), rand(UInt64, 2),
                     rand(Int128, 2), rand(UInt128, 2))
             end')
   testEcho(juliaEval("TestTypeWithAllKindsOfStuff()"))
})


test_that("Private inner constructor is forged", {
   juliaEval('struct MyPrivateX
            x::Int
            function MyPrivateX()
               new(5)
            end
          end')
   p <- juliaEval("MyPrivateX()")
   testEcho(p)
})


test_that("Imported modules are printed", {
   # a stdlib module
   Pkg <- juliaImport("Pkg")
   expect_match(regexp = 'Julia module "Pkg": [0-9]+ function.*',
                capture.output(print(Pkg))[1])

   # a user defined module
   module <- juliaEval('module ImportTestModule1
               export f
               f(x)=1
             end')
   itm1 <- juliaImport(module, all = FALSE)
   expectedOutput <-
      'Julia module "Main.ImportTestModule1": 1 function.*'
   expect_match(capture.output(print(itm1))[1], regexp = expectedOutput)

   itm1_2 <- juliaImport(".ImportTestModule1", all = FALSE)
   expect_match(capture.output(print(itm1_2))[1], regexp = expectedOutput)
})


test_that("Empty module does not cause problems", {
   juliaEval("module EmptyTestModule end")
   expect_length(ls(juliaImport(".EmptyTestModule")), 2) # (eval and include)
   juliaEval("module EmptyTestModule2 end")
   expect_length(ls(juliaImport(".EmptyTestModule2", all = FALSE)), 0)
})


test_that("Errors are handled gracefully", {
   expect_error(juliaCall("sum", c(1,2,3, "bla")))
   expect_error(juliaCall("thisisnotarealfunction", 100, 4))
   expect_error(juliaCall("RConnector.thisisnotarealfunction", "haha"))
   expect_error(juliaCall("NotARealModule.thisisnotarealfunction", list(1,2,3)))
})


test_that("Vectors of objects can be accessed by index via proxy", {
   x <- juliaEval("[ [1;2;3], [4;5;6], [7;8;9] ]")
   expect_s3_class(x, "JuliaArrayProxy")
   expect_equal(x[[1]][2], 2)
   expect_equal(x[[2]][2], 5)
   x[[1]][1] <- 17L
   expect_equal(x[[1]][1], 17)
   expect_equal(x[2:3][[1]][[1]], 4)
   x[2:3][[1]][[1]] <- 18L
   expect_equal(x[2:3][[1]][[1]], 18)

   expect_equal(x[[1]][x[[2]] == 5], 2) # logical indexing

   # juliaGet version must behave in the same way as the proxy version
   y <- juliaGet(x)
   expect_equal(x[[2]], y[[2]])
   expect_equal(x[[1]][2], y[[1]][2])
   expect_equal(x[[2]][2], y[[2]][2])
   x[[1]][1] <- 17L
   y[[1]][1] <- 17L
   expect_equal(x[[1]][1], 17)
   expect_equal(y[[1]][1], 17)
   x[2:3][[1]][[1]] <- 18L
   y <- juliaGet(x)
   expect_equal(y[2:3][[1]][[1]], 18)
   expect_equal(x[2:3][[1]][1], y[2:3][[1]][1])
   expect_equal(x[[2]], y[[2]])

   # Multiple dimensions
   y <- juliaEval("map( x-> [1;x;3], rand(2,2,2))")
   expect_equivalent(y[c(1,2)][[1]], y[[1]])
   expect_equivalent(y[c(1,3)][[2]], y[[3]])
   y[c(1,3)] <- juliaEval("[[17.0], [18.0]]")
   expect_equivalent(juliaGet(y[1]), list(17))
   expect_equivalent(juliaGet(y[3]), list(18))
   expect_equivalent(juliaGet(y)[c(4,5)], juliaGet(y[c(4,5)]))
})


test_that("Callback functions", {

   x <- juliaEcho(function() {})
   expect_equal(typeof(x), "closure")
   expect_equal(x, function() {})

   outputenv <- new.env(parent = emptyenv())
   outputenv$output <- c()
   doOutput <- function(x) {
      outputenv$output <- c(outputenv$output, x)
   }

   # Nested callback functions
   juliaEval('struct TestStruct f::Function end')
   juliaEval('function testNestedFun(ts::Vector{TestStruct}) map(t -> t.f(), ts) end')
   t <- juliaCall("testNestedFun",
                  list(juliaCall("TestStruct", function() {doOutput("a")}),
                       juliaCall("TestStruct", function() {doOutput("b")}),
                       juliaCall("TestStruct", function() {doOutput("c")})))
   expect_equal(outputenv$output, c("a", "b", "c"))

   # as named arguments
   outputenv$output <- c()
   juliaEval('function testNestedFunNamed(;ts::Vector{TestStruct}) map(t -> t.f(), ts) end')
   t <- juliaCall("testNestedFunNamed", ts =
                     list(juliaCall("TestStruct", function() {doOutput("x")}),
                          juliaCall("TestStruct", function() {doOutput("y")})))
   expect_equal(outputenv$output, c("x", "y"))


   # test repeated call of nested functions
   outputenv$output <- c()
   juliaEval('function testNestedFun2(ts::Vector{TestStruct}) for i = 1:2 map(t -> t.f(), ts) end end')
   t <- juliaCall("testNestedFun2",
                  list(juliaCall("TestStruct", function() {doOutput(1)}),
                       juliaCall("TestStruct", function() {doOutput(2)})))
   expect_equal(outputenv$output, c(1,2,1,2))

   # Test multiple arguments
   outputenv$output <- c()
   juliaEval('function testNestedFunArgs(ts::Vector{TestStruct}, args...) map(t -> t.f(args...), ts) end')
   t <- juliaCall("testNestedFunArgs",
                  list(juliaCall("TestStruct", function(x, y, z) {doOutput(x)}),
                       juliaCall("TestStruct", function(x, y, z) {doOutput(z); return(c(5,6,7))})),
                  1, 2, 3)
   expect_equal(outputenv$output, c(1,3))


   outputenv$output <- c()
   juliaEval('function testNestedAndUnnested(f::Function, ts::Vector{TestStruct}, args...)
             testNestedFunArgs(ts, args...)
             f(args...)
             end')

   t <- juliaCall("testNestedAndUnnested",
                  function(x, y) {doOutput(x)},
                  list(juliaCall("TestStruct", function(x,y) {doOutput(x)}),
                       juliaCall("TestStruct", function(x, y) {doOutput(y); return(list(5,6,7))})),
                  17,18)
   expect_equal(outputenv$output, c(17, 18, 17))
})


test_that("Callback function calling Julia erroring in Julia", {
   f <- juliaEval('(x) -> error("Error")')
   g <- function(x) {cat("OK"); f(x); print("NotOK"); x}
   output <- capture.output(expect_error(juliaCall("map", g, c(1,2,3))))
   expect_equal(output, "OK")
})


test_that("Builtin functions can be used as callback functions", {
   expect_equal(juliaCall("map", sqrt, c(1,4,9)), c(1,2,3))
})


test_that("Callback function might have error in R", {

   fOK <- function(x) { return(x+1) }
   fnotOK <- function(x) {
      if (x == 2) {
         stop("No even numbers please")
      } else {
         return(1)
      }
   }
   expect_equal(juliaCall("map", fOK, c(1,2,3)), c(2,3,4))
   expect_error(juliaCall("map", fnotOK, c(1,2,3)), class = "error")
})


test_that("Julia functions as members are transferred and usable in R", {
   op1 <- juliaFun("+")
   juliaEval('struct FunTestStruct f::Function end')
   funTestStruct <- juliaCall("FunTestStruct", op1)
   expect_equal(funTestStruct$f(1,2), 3)
})


test_that("juliaCall checks given name before running", {
   expect_error(juliaCall())
   expect_error(juliaCall(1))
   expect_error(juliaCall(c("bla", "bla")))
})


test_that("juliaCall can handle keyword arguments with key \"name\"", {
   Pkg <- juliaImport("Pkg")
   # indirect via created function object
   expect_equal(Pkg$PackageSpec(name = "RData", version = "v0.10")$name,
                "RData")
   # direct call of juliaCall
   pkgspec <- juliaCall("Pkg.PackageSpec", name = "RData", version = "0.10")
   expect_equal(pkgspec$name, "RData")
})


test_that("Documentation example of juliaFun", {
   juliaSqrt <- juliaFun("sqrt")
   expect_equal(juliaSqrt(2), sqrt(2))
   expect_equal(juliaCall("map", juliaSqrt, c(1,4,9)), c(1,2,3))
})


test_that("Constructors stand for their types", {
   juliaEval('module TestTypeModule
                export TestType
                struct TestType end
             end')
   TestTypeModule <- juliaImport(".TestTypeModule")
   expect_equal(as.character(juliaCall("typeof", TestTypeModule$TestType)),
                "DataType")
})


test_that("Parametric types are imported", {
   juliaEval("module ParametricTypeTestModule
               export MyParametricType
               struct MyParametricType{T}
                  i::T
               end
             end")
   ParametricTypeTestModule <- juliaImport(".ParametricTypeTestModule")
   expect_equal(ParametricTypeTestModule$MyParametricType(2)$i, 2)
   expect_equal(ParametricTypeTestModule$MyParametricType("bla")$i, "bla")
})


test_that("Starting and stopping Julia server" , {
   stopJulia()
   port <- startJuliaServer()
   expect_match(Sys.getenv("JULIACONNECTOR_SERVER"), paste0("localhost:", port))

   # starting the server twice should give a warning and not do anything
   expect_warning(startJuliaServer())
   expect_match(Sys.getenv("JULIACONNECTOR_SERVER"), paste0("localhost:", port))

   # now the server should start successfully
   expect_equal(juliaEval("1"), 1)

   # set a variable in a separate process:
   rPath <- file.path(R.home("bin"), "R")
   if (Sys.info()["sysname"] == "Windows") {
      rPath <- paste0(rPath, ".exe")
   }
   system2(rPath, c("-e", shQuote(
      paste0("library(JuliaConnectoR); juliaEval('global x = 1')"))),
      stdout = FALSE)

   # check that variable is set in this Julia session,
   # i.e. that the two R processes share the same Julia process
   expect_equal(juliaEval("x"), 1)

   stopJulia()
   expect_equal(Sys.getenv("JULIACONNECTOR_SERVER"), "")
   expect_null(JuliaConnectoR:::pkgLocal$con)
})


test_that("Julia startup options can be modified", {
   stopJulia()
   oldJuliaOpts <- Sys.getenv("JULIACONNECTOR_JULIAOPTS")

   # set project directory via startup opts
   projectPathWithSpaces <- file.path(tempdir(), "Dirname with Spaces")
   dir.create(file.path(tempdir(), "Dirname with Spaces"))
   specifyProjectOpts <- paste0('--project="', projectPathWithSpaces, '"')
   Sys.setenv("JULIACONNECTOR_JULIAOPTS" = paste0('--project="',
                                                  projectPathWithSpaces, '"'))
   expect_match(capture.output({juliaEval("import Pkg; Pkg.status()")}),
                regexp = "Dirname with Spaces", fixed = TRUE, all = FALSE)
   stopJulia()

   # set two startup opts: project directory and deprecation warnings
   Sys.setenv("JULIACONNECTOR_JULIAOPTS" = paste(specifyProjectOpts,
                                                "--depwarn=no"))
   juliaDepWarn <- 'Base.depwarn("there is a deprecation warning", :foo)'
   expect_length(capture.output({juliaEval(juliaDepWarn)}), 0)
   stopJulia()

   # clean up
   unlink(projectPathWithSpaces, recursive = TRUE)
   if (oldJuliaOpts == '') {
      Sys.unsetenv("JULIACONNECTOR_JULIAOPTS")
   } else {
      Sys.setenv("JULIACONNECTOR_JULIAOPTS" = oldJuliaOpts)
   }
})


test_that("JULIACONNECTOR_SERVER environment variable and Killing Julia works", {
   # if JULIACONNECTOR_SERVER is used, the server must be started with
   # "keeprunning = true" to work.
   skip_on_cran()
   JuliaConnectoR:::stopJulia()
   oldJuliaConnectorServer <- Sys.getenv("JULIACONNECTOR_SERVER")
   # start new JuliaConnectoR server
   port <- JuliaConnectoR:::startJuliaServer(12980)
   expect_match(Sys.getenv("JULIACONNECTOR_SERVER"), paste0("localhost:", port))

   # test with wrong variable
   Sys.setenv("JULIACONNECTOR_SERVER" = "wrong form")
   expect_error(JuliaConnectoR:::startJulia(), regexp = "<host>:<port>")

   # now for real
   Sys.setenv("JULIACONNECTOR_SERVER" = paste("localhost", port, sep = ":"))
   # test some command, if it works
   expect_equal(juliaCall("prod", c(1,2)), 2)
   # test killing
   JuliaConnectoR:::killJulia()
   if (oldJuliaConnectorServer == "") {
      Sys.unsetenv("JULIACONNECTOR_SERVER")
   } else {
      Sys.setenv("JULIACONNECTOR_SERVER" = oldJuliaConnectorServer)
   }
})


test_that("Error if Julia is not setup properly", {
   oldJuliaBindir <- Sys.getenv("JULIA_BINDIR")
   Sys.setenv("JULIA_BINDIR" = "/this/isnot/a/directory/")
   expect_error(JuliaConnectoR:::runJuliaServer(16752), "No Julia executable file found")
   if (oldJuliaBindir == "") {
      Sys.unsetenv("JULIA_BINDIR")
   } else {
      Sys.setenv("JULIA_BINDIR" = oldJuliaBindir)
   }
   expect_equal(1, juliaEval("1"))
})


test_that("Circular references do not lead to a crash", {

   definition <- 'mutable struct TestRecur
                  r::Union{TestRecur, Int}
                  end'
   try({juliaEval(definition)}, silent = TRUE) # (ignore redefinition error)

   r <- juliaEval("r1 = TestRecur(2); r2 = TestRecur(r1); r1.r = r2; r1")
   expect_match(capture.output({print(juliaEcho(r))}), regex = "circular reference", all = FALSE)
   expect_error(juliaEcho(juliaGet(r)), regex = "Circular reference")

   # reference only
   r <- juliaEval("r1 = TestRecur(2); r2 = TestRecur(r1); r1.r = r2; r1")
   expect_match(capture.output({print(juliaEcho(r))}), regex = "circular reference", all = FALSE)
   expect_equal(juliaCall("typeof", r$r$r), juliaCall("typeof", r))
})


test_that("Anonymous functions can be transferred", {
   af1 <- juliaEval("() -> 17")
   expect_equal(af1(), 17)
   expect_equal(juliaEcho(af1)(), 17)
   rm(af1)

   af2 <- juliaEval("(args...; kwargs...) -> 19")
   expect_equal(af2(list(), 3, bla = 2), 19)
   rm(af2)

   # Test cleaning of references
   invisible(gc(verbose = FALSE))
   expect_gt(length(JuliaConnectoR:::pkgLocal$finalizedRefs), 0)
   juliaEval("1")
   expect_null(JuliaConnectoR:::pkgLocal$finalizedRefs)


   juliaEval("struct TestAnonFunStruct
               f::Function
             end")
   afs <- juliaEval("TestAnonFunStruct(() -> 20)")
   expect_equal(afs$f(), 20)
})


test_that("Test BigInt: a Julia object with external pointers", {

   # Note: It is not really recommended to translate objects with
   # external pointers. Nevertheless, it should work and not cause a crash.

   i1 <- juliaGet(juliaCall("BigInt", 2147483647L))
   i2 <- juliaGet(juliaCall("BigInt", 2147483647L))
   p <- juliaGet(juliaCall("prod", list(i1, i2, i1)))
   p2 <- juliaGet(juliaCall("prod", list(i1, i2, i1)))
   juliaCall("GC.gc") # references in sharedheap must survive this
   jldiv <- juliaFun("div")
   expect_equal(juliaCall("Int", jldiv(jldiv(p,i1), i2)), 2147483647L)
   expect_equal(juliaLet("Int(div(div(p,i1),i2))", p = p, i1 = i1, i2 = i2),
                2147483647)

   f <- juliaLet("p/i1/i2", p = p, i1 = i1, i2 = i2)
   expect_equal(juliaCall("Float64", f), 2147483647)

   i1Ref <- attr(i1, "JLREF")$ref
   expect_true(juliaLet("communicator.sharedheap[ref].refcount > 0",
                        ref = i1Ref, communicator = pkgLocal$communicator))
   i1 <- NULL
   invisible(gc())
   juliaEval("1") # after one command, the references from R should be cleaned up

   # Multiple calls to the Julia garbage are necessary for a complete clean-up as
   # one finalization may make another object unreachable, which will then
   # be cleaned up in the next run.
   juliaCall("GC.gc")
   juliaCall("GC.gc")
   juliaCall("GC.gc")
   expect_false(juliaLet("haskey(communicator.sharedheap, ref)", ref = i1Ref,
                         communicator = pkgLocal$communicator))
})


test_that("Serialized mutable struct can be restored", {
   juliaEval("mutable struct TestSerializationStruct
               i::Int
             end")
   x <- juliaGet(juliaEval("TestSerializationStruct(1)"))
   tmpfile <- tempfile()
   save("x", file = tmpfile)
   x <- NULL
   #juliaEval("println(RConnector.sharedheap)")
   invisible(gc())
   juliaEval("1")
   juliaCall("GC.gc")
   load(tmpfile)
   msg <- capture.output(type = "message", {
      expect_equal(juliaEcho(x)$i, 1)
   })
   expect_match(msg, "external references", all = FALSE)
   x <- NULL
   juliaEval("1")
   juliaCall("GC.gc") # copy of the serialized copy is cleaned up
   file.remove(tmpfile)
})


test_that("Object with unexported function defined in different modules", {
   juliaEval('
   module FirstModule
      struct FirstType
         f::Function
      end
      f(x::FirstType) = 1
   end

   module SecondModule

      import ..FirstModule.f
      struct SecondType
         f::Function
      end

      f(x::SecondType) = 2
   end #module')

   # It doesn't matter whether SecondModule.f or FirstModule.f is used
   ft1 <- juliaEval("FirstModule.FirstType(SecondModule.f)")
   ft2 <- juliaEval("SecondModule.SecondType(FirstModule.f)")

   expect_equal(juliaLet("x.f(x)", x = ft1), 1)
   expect_equal(juliaLet("x.f(x)", x = ft2), 2)
   expect_equal(juliaLet("x.f(y)", x = ft1, y = ft2), 2)
   expect_equal(juliaLet("x.f(y)", x = ft2, y = ft1), 1)
})


test_that("AbstractArrays are transferred by reference and can be translated to struct", {
   a <- juliaEval('using SparseArrays
             A = sparse([1, 2, 3], [1, 2, 3], [0, 2, 0])')
   expect_s3_class(a, "JuliaArrayProxy")
   # indexing
   expect_equal(a[[2,2]], 2)
   # backtranslation
   expect_true(juliaCall("issparse", juliaGet(a)))
   testEcho(a)
})


test_that("Operators can be imported and used", {
   suppressWarnings({jla <- juliaImport("LinearAlgebra", all = FALSE)})
   expect_equal(jla$`<cdot>`(1,2), 2)
   suppressWarnings({base <- juliaImport("Base", all = FALSE)})
   expect_true(base$`<subseteq>`(c(1,2), c(1,2,3)))
})


test_that("Boltzmann machine can be trained and used", {
   #skip_on_cran()

   juliaEval('using Pkg;
              try
                 @eval import BoltzmannMachines
              catch ex
                 Pkg.add(PackageSpec(name = "BoltzmannMachines", version = v"1.2"))
              end')

   # Set a random seed in Julia
   juliaEval("using Random; Random.seed!(5);")

   BM <- juliaImport("BoltzmannMachines")

   # a test data set from the BoltzmannMachines-package, just to have some data
   x <- BM$barsandstripes(50L, 4L)
   x

   # Train DBMs with
   dbm <- BM$fitdbm(x, epochs = 2L, nhiddens = c(4L,3L))
   dbm
   dbm2 <- BM$fitdbm(x, epochs = 1L,
                     pretraining = list(BM$TrainLayer(nhidden = 4L),
                                        BM$TrainLayer(nhidden = 3L)))
   dbm2 <- juliaGet(dbm2)

   # Use a trained model to generate samples
   gensamples <- BM$samples(dbm, 10L)
   expect_equal(nrow(gensamples), 10)

   # Evaluate the model: Likelihood estimation ...
   BM$loglikelihood(dbm2, x)
   #  ... or exact calculation (possible for such a small model)
   BM$exactloglikelihood(dbm2, x)
})


test_that("juliaPut", {
   x <- juliaPut(c(1,2,3))
   expect_s3_class(x, "JuliaSimpleArrayProxy")
   expect_equal(x[[1]], 1)
   expect_equal(x[1:2], c(1,2))
   expect_type(x[3], "double")
   x[2:3] <- 0
   expect_equal(juliaCall("sum", x), 1)

   expect_error(juliaPut(juliaEval("(a=1,b=2,c=3)")))

   x <- juliaPut("bla")
   expect_equal(as.character(juliaCall("typeof", x)), "String")

   # use on translated object
   x <- juliaGet(juliaEval("[(1,2), (2,3)]"))
   expect_s3_class(juliaPut(x), "JuliaArrayProxy")
})


test_that("Display of default printing is limited to width", {
   x <- juliaEval("rand(100, 100)")
   y <- juliaPut(x)
   printOutput <- capture.output({print(y)})
   expect_lte(nchar(printOutput[length(printOutput)]),
              getOption("width"))
})


test_that("Error message for tables", {
   capture.output({JuliaConnectoR:::showUpdateTablesMsg()})

   x <- juliaEcho(list(c(1,2), c(1,2,3)))
   expect_s3_class(x, "JuliaProxy")
   expect_error({as.data.frame(x)})
})


test_that("Data frame can be translated", {
   x <- data.frame(x = c(0, 2, 4), y = c("bla", "blup", "ha"),
                   stringsAsFactors = FALSE)
   testEcho(x)
   y <- juliaEcho(x)

   x2 <- as.data.frame(juliaEcho(x))
   expect_s3_class(x2, "data.frame")
   expect_equal(x2$x, c(0,2,4))
   expect_equal(x2$y, c("bla", "blup", "ha"))

   testEcho(data.frame())

   Pkg <- juliaImport("Pkg")
   if (juliaEval('VERSION < v"1.6"')) {
      subproject <- "1_0"
   } else {
      subproject <- "1_6"
   }
   Pkg$activate(system.file("examples", "IndexedTables-Project", subproject,
                            package = "JuliaConnectoR"))
   Pkg$instantiate()
   juliaEval("import IndexedTables")
   x <- data.frame(x = c(0, 2, 4), y = c("bla", "blup", "ha"),
                   stringsAsFactors = FALSE)
   y <- juliaCall("IndexedTables.table", x)
   expect_equal(as.data.frame(x), x)

   # Works also without column names (Issue #16)
   df <- juliaCall("IndexedTables.table", 1:3, 11:13)
   df <- as.data.frame(df)
   expect_equal(df[, 1], 1:3)
   expect_equal(df[, 2], 11:13)
})


test_that("Attempt to translate Julia Table with incompatible types results in proper error", {
   juliaEval("import IndexedTables")
   x <- juliaEval('IndexedTables.table(["a", 1, 2], [1,2,3])')
   expect_error(as.data.frame(x), regexp = 'Column type "Any" cannot be translated')
})


test_that("Julia types are converted to r compatible types in data frames", {
   x1 <- juliaEval("[1.0f0*im + 1.0f0, 0.0f0]")
   x2 <- juliaEval('map(i -> SubString(i, 2,3), ["asdf", "wert"])')
   x3 <- juliaEval('[true, false]')
   x4 <- juliaEval("['a', 'b']")
   x <- juliaLet('Dict(:x1 => x1, :x2 => x2, :x3 => x3, :x4 => x4)',
            x1 = x1, x2 = x2, x3 = x3, x4 = x4)
   x <- as.data.frame(x)
   expect_equivalent(x$x1, x1)
   expect_equal(x$x2, c("sd", "er"))
   expect_equal(x$x3, x3)
   expect_equivalent(x$x4, x4)
})


test_that("Broadcasting via dot syntax works", {
   expect_equal(juliaCall("sin.", c(0, 1/3*pi, pi/2)),
                c(0, sqrt(3)/2, 1))
   juliaEval("import Statistics")
   arrofarrs <- juliaEval("[[2;3], [4;5]]")
   expect_equal(juliaCall("Statistics.mean.", arrofarrs), c(2.5, 4.5))
   expect_equal(juliaGet(juliaCall("Statistics.mean.", arrofarrs, dims = 1L)),
                juliaGet(juliaEval("[[2.5], [4.5]]")))

   # Test functions with multiple arguments
   juliaEval("module TestBroadcasting
                 function my_add(x,y) x+y end
                 function my_mul(x,y) x*y end
             end")
   expect_equal(juliaCall("TestBroadcasting.my_add.", 10, c(1,2,3)),
                juliaEval("TestBroadcasting.my_add.(10, [1, 2, 3])"))
   expect_equal(juliaCall("TestBroadcasting.my_mul.", c(1,2,3), c(4,5,6)),
                juliaEval("TestBroadcasting.my_mul.([1, 2, 3], [4, 5, 6])"))
   # Check that dimension mismatch leads to an error
   expect_error(juliaCall("TestBroadcasting.my_mul.", c(1,2,3,4), c(5,6)))
})


test_that("Environemnt variables for Julia can be set", {
   # prepare
   os <- Sys.info()['sysname']
   oldJuliaEnv <- Sys.getenv("JULIACONNECTOR_JULIAENV")
   JuliaConnectoR:::stopJulia()

   # Test with one variable
   Sys.setenv(JULIACONNECTOR_JULIAENV = "TESTVARIABLE1=1")
   if (os == "Windows") {
      expect_warning(juliaEval("1+1"))
   } else {
      expect_equal(juliaEval('ENV["TESTVARIABLE1"]'), "1")
   }
   JuliaConnectoR:::stopJulia()

   # Test with two variables
   Sys.setenv(JULIACONNECTOR_JULIAENV = "TESTVARIABLE1=1; TESTVARIABLE2='abc'")
   if (os == "Windows") {
      expect_warning(juliaEval("1+1"))
   } else {
      expect_equal(juliaEval('ENV["TESTVARIABLE1"]'), "1")
      expect_equal(juliaEval('ENV["TESTVARIABLE2"]'), "abc")
   }
   JuliaConnectoR:::stopJulia()

   # LD_LIBRARY_PATH can be set via JULIACONNECTOR_JULIAENV
   Sys.setenv(JULIACONNECTOR_JULIAENV = "LD_LIBRARY_PATH='abc'")
   if (os == "Linux") {
      expect_match(JuliaConnectoR:::getJuliaEnv(), "LD_LIBRARY_PATH='abc'")
   }

   # clean up
   if (oldJuliaEnv == "") {
      Sys.unsetenv("JULIACONNECTOR_JULIAENV")
   } else {
      Sys.setenv(JULIACONNECTOR_JULIAENV = oldJuliaEnv)
   }
})


test_that("Iris/Flux example from README works", {
   skip_on_cran()
   skip_on_covr()
   #skip_if(Sys.info()["login"] %in% c("lenz", "Stefan Lenz", "selectstern", "lenzstef"))
   cat("\nExecuting README examples...\n")

   if (juliaEval('VERSION < v"1.9"')) {
      skip("Skip Flux example because Julia version is too old")
   } else {
      projectFolder <- "project_1_9"
   }

   Pkg <- juliaImport("Pkg")
   Pkg$activate(system.file("examples", "iris-example", projectFolder,
                            package = "JuliaConnectoR", mustWork = TRUE))
   Pkg$instantiate()

   irisExampleJl <- system.file("examples", "iris-example", "iris-example.jl",
                                package = "JuliaConnectoR", mustWork = TRUE)
   irisExampleJuliaCode <- readLines(irisExampleJl)
   juliaEval(paste(irisExampleJuliaCode, collapse = "\n"))
   expect_true(juliaEval("accuracy(model, testdata) > 0.9"))

   irisExampleR <- system.file("examples",  "iris-example", "iris-example.R",
                               package = "JuliaConnectoR", mustWork = TRUE)
   irisExampleRCode <- readLines(irisExampleR)

   scriptEnv <- new.env(emptyenv())
   suppressWarnings(eval(parse(text = paste(irisExampleRCode, collapse = "\n")),
                         envir = scriptEnv))

   # Test that training the model worked
   print(juliaCall("accuracy", scriptEnv$model, scriptEnv$testdata))
   expect_true(juliaCall("accuracy", scriptEnv$model, scriptEnv$testdata) > 0.9)

   Pkg$activate() # use default environment again
})



test_that("Boltzmann example from README works", {
   skip_on_cran()
   returningError <- function(x) {
      paste0("tryCatch({", x , '},',
             'error = function(e) { paste("e: ",e$message) },',
             'warning = function(w) { paste("w: ", w$message) })')
   }

   juliaEval('import Pkg;
            try
               @eval import BoltzmannMachines
            catch ex
               Pkg.add(PackageSpec(name = "BoltzmannMachines", version = v"1.3"))
            end')
   boltzmannExampleR <- system.file("examples", "boltzmann-example.R",
                                     package = "JuliaConnectoR", mustWork = TRUE)
   bmExample <- readLines(boltzmannExampleR)
   bmExample <- sub("plot\\(.*", "", bmExample)
   bmScriptEnv <- new.env(emptyenv())
   code <- paste(bmExample, collapse = "\n")
   code <- returningError(code)
   eval(parse(text = code), envir = bmScriptEnv)
   expect_s3_class(bmScriptEnv$dbm, "JuliaProxy")
})

test_that("Example for AccessMutate.JuliaProxy works", {
   # (Mutable) struct
   juliaEval("mutable struct MyStruct
                x::Int
             end")

   MyStruct <- juliaFun("MyStruct")
   s <- MyStruct(1L)
   s$x
   s$x <- 2
   expect_equal(s[["x"]], 2)


   # Array
   x <- juliaCall("map", MyStruct, c(1L, 2L, 3L))
   x
   expect_equal(length(x), 3)
   x[[1]]
   x[[1]]$x
   x[[1]] <- MyStruct(2L)
   x[2:3]
   x[2:3] <- MyStruct(2L)
   expect_equal(juliaLet("[myx.x for myx in x]", x = x), c(2,2,2))

   # Tuple
   x <- juliaEval("(1, 2, 3)")
   expect_equal(x[[1]], 1)
   expect_s3_class(x[1:2], "JuliaProxy")
   expect_equal(length(x), 3)

   # NamedTuple
   x <- juliaEval("(a=1, b=2)")
   expect_equal(x$a, 1)

   # Dictionary
   strDict <- juliaEval('Dict("hi" => 1, "hello" => 2)')
   strDict
   expect_equal(strDict$hi, 1)
   strDict$hi <- 0
   strDict[["hi"]] <- 2
   strDict["howdy", "greetings"] <- c(2, 3)
   expect_equal(strDict["hi", "howdy"], list(2,2))

})

library(testthat)

juliaEcho <- function(x) juliaCall("identity", x)

jlRefsRemoved <- function(x) {
   if (is.list(x)) {
      if (!is.null(attr(x, "JLREF"))) {
         attr(x, "JLREF") <- NULL
      }
      for (i in seq_along(x)) {
         if (!is.null(x[[i]])) {
            x[[i]] <- jlRefsRemoved(x[[i]])
         }
      }
      return(x)
   } else if (is.environment(x) && inherits(x, "JuliaProxy")) {
      return(jlRefsRemoved(juliaGet(x)))
   } else {
      return(x)
   }
}


testEcho <- function(x, comparableInJulia = TRUE) {
   if (is.list(x)) {
      expect_identical(jlRefsRemoved(x), jlRefsRemoved(juliaEcho(x)))
   } else if (is.environment(x) && inherits(x, "JuliaProxy")) {
      if (comparableInJulia) {
         expect_true(juliaCall("==", x, juliaEcho(x)))
      }
      testEcho(juliaGet(x))
   } else {
      expect_equivalent(x, juliaEcho(x))
   }
}
